      SUBROUTINE timestep(imode)
C=========================================================================
C===
C===  task: compute initial time step 
C===  -----
C===
C=========================================================================
C===                                                   17/08/2006 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"

C---  local vars
      INTEGER          i,ip,power,imode
      DOUBLE PRECISION a2_mod,adot2_mod,tmp


      IF (imode.NE.1) THEN      ! get time step for all active particles

C---  loop over local particles and compute initial time step
         DO i=1,n_loc
            
            a2_mod    =   a_loc(1,i)*a_loc(1,i)
     $                  + a_loc(2,i)*a_loc(2,i)
     $                  + a_loc(3,i)*a_loc(3,i)
            adot2_mod =   adot_loc(1,i)*adot_loc(1,i)
     $                  + adot_loc(2,i)*adot_loc(2,i)
     $                  + adot_loc(3,i)*adot_loc(3,i)


C---  get time step 
            IF (adot2_mod.EQ.0.d0) THEN
               tmp = eta_s
            ELSE
               tmp = eta_s*SQRT(a2_mod/adot2_mod)
            ENDIF           

C---  set time step to power of two value
            power = INT(LOG(tmp)/log(2.d0)) - 1
            tmp   = 2.d0**power

            IF (tmp.GT.dt_max) tmp = dt_max ! limit maximum time step
            IF (tmp.LT.dt_min) THEN
               WRITE(0,500) myRank,i,tmp,dt_min,time_cur
 500           FORMAT('PE',I2.2,': Warning! time step for particle'
     $              ,I8,' smaller than dt_min',3E14.6)
               tmp = dt_min     
            ENDIF
            dt_loc(i) = tmp

         ENDDO


      ELSE                      ! get timestep for active particle 
                                ! (active = new)

C---  loop over active particles and compute initial time step
         DO i=1,n_act_loc

            ip        = ind_act_loc(i)

            a2_mod    =   a_loc(1,ip)*a_loc(1,ip)
     $                  + a_loc(2,ip)*a_loc(2,ip)
     $                  + a_loc(3,ip)*a_loc(3,ip)
            adot2_mod =   adot_loc(1,ip)*adot_loc(1,ip)
     $                  + adot_loc(2,ip)*adot_loc(2,ip)
     $                  + adot_loc(3,ip)*adot_loc(3,ip)


C---  get time step 
            IF (adot2_mod.EQ.0.d0) THEN
               tmp = eta_s
            ELSE
               tmp = eta_s*SQRT(a2_mod/adot2_mod)
            ENDIF           

C---  set time step to power of two value
            power = INT(LOG(tmp)/log(2.d0)) - 1
            tmp   = 2.d0**power

            IF (tmp.GT.dt_max) tmp = dt_max ! limit maximum time step
            IF (tmp.LT.dt_min) THEN
               WRITE(0,500) myRank,i,tmp,dt_min,time_cur
               tmp = dt_min     
            ENDIF

            DO WHILE ((tmp*DBLE(INT(t_loc(ip)/tmp))) .NE. t_loc(ip))
                tmp = 0.5d0 * tmp
                IF (tmp.LT.dt_min) THEN
                   WRITE(0,500) myRank,i,tmp,dt_min,time_cur
                   tmp = dt_min
                   EXIT
                ENDIF
            ENDDO

C---  setting time step
            dt_loc(ip) = tmp

         ENDDO
      ENDIF

      RETURN
      END

      SUBROUTINE sendbodydata
C=========================================================================
C===
C===  task: scatter the nbody data to all nodes, local body data is
C===  ----- stored in arrays ending in '_loc'
C===
C=========================================================================
C===                                                   17/08/2006 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"
#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'

C---  local vars
      INTEGER ierr

C---  Scatter the "local" vectors from "global" 
      
      CALL MPI_Scatter(ind, n_loc, MPI_INTEGER,  ind_loc, n_loc,
     $                  MPI_INTEGER, rootRank, MPI_COMM_WORLD,ierr)
     
      CALL MPI_Scatter(m,   n_loc, MPI_DOUBLE_PRECISION, m_loc,   n_loc,
     $                      MPI_DOUBLE_PRECISION, rootRank, 
     $                      MPI_COMM_WORLD,ierr)
      CALL MPI_Scatter(h,   n_loc, MPI_DOUBLE_PRECISION, h_loc,   n_loc,
     $                      MPI_DOUBLE_PRECISION, rootRank, 
     $                      MPI_COMM_WORLD,ierr)
      CALL MPI_Scatter(t,   n_loc, MPI_DOUBLE_PRECISION, t_loc,   n_loc,
     $                      MPI_DOUBLE_PRECISION, rootRank, 
     $                      MPI_COMM_WORLD,ierr)
      CALL MPI_Scatter(dt,  n_loc, MPI_DOUBLE_PRECISION, dt_loc,  n_loc,
     $                      MPI_DOUBLE_PRECISION, rootRank, 
     $                      MPI_COMM_WORLD,ierr)
      CALL MPI_Scatter(x, 3*n_loc, MPI_DOUBLE_PRECISION, x_loc, 3*n_loc,
     $                      MPI_DOUBLE_PRECISION, rootRank, 
     $                      MPI_COMM_WORLD,ierr)
      CALL MPI_Scatter(v, 3*n_loc, MPI_DOUBLE_PRECISION, v_loc, 3*n_loc,
     $                      MPI_DOUBLE_PRECISION, rootRank, 
     $                      MPI_COMM_WORLD,ierr)

C---  this data only needs scattering when restarting
      IF (irestart.EQ.1) THEN

         CALL MPI_Scatter(a, 3*n_loc, MPI_DOUBLE_PRECISION, a_loc, 
     $                     3*n_loc, MPI_DOUBLE_PRECISION, rootRank,
     $                      MPI_COMM_WORLD,ierr)
         CALL MPI_Scatter(adot, 3*n_loc, MPI_DOUBLE_PRECISION, adot_loc,
     $                       3*n_loc, MPI_DOUBLE_PRECISION, rootRank, 
     $                      MPI_COMM_WORLD,ierr)
         CALL MPI_Scatter(pot,  n_loc, MPI_DOUBLE_PRECISION, pot_loc, 
     $                       n_loc, MPI_DOUBLE_PRECISION, rootRank,
     $                      MPI_COMM_WORLD,ierr)
      ENDIF

#ifdef DEBUG
       WRITE(STDERR,600) myRank,n_loc,ind_loc(1),ind_loc(n_loc)
 600   FORMAT (' PE',I2.2,': ',I10,' local particles (first and last) '
     $      ,2I10)
#endif

#endif

      RETURN
      END

      SUBROUTINE corrector
      IMPLICIT NONE
#include "general.inc"

C---  local vars
      INTEGER i,k,ii,power,kanew,kjnew
      DOUBLE PRECISION dt_tmp,dt3over6,dt4over24,dt5over120,
     $                 dtinv,dt2inv,dt3inv,
     $                 a2(NDIM),a3(NDIM),a1abs,adot1abs,
     $                 a2dot1(NDIM),a2dot1abs,a3dot1abs,dt_new

C---  functions
      DOUBLE PRECISION dmod


C---  get first index of local active particle
      ii = disp_act_v(myRank+1)

      DO i=1,n_act_loc

         dt_tmp     = dt_act(i)

         dt3over6   = dt_tmp*dt_tmp*dt_tmp/6.d0
         dt4over24  = dt3over6*dt_tmp/4.d0
         dt5over120 = dt4over24*dt_tmp/5.d0

         dtinv      = 1.d0/dt_tmp
         dt2inv     = dtinv*dtinv
         dt3inv     = dt2inv*dtinv


         DO k=1,NDIM
            kanew = iaxnew+k-1 
            kjnew = ijxnew+k-1 
            a2(k) = -  6.d0 * (   a_act(k,i)
     $                          - body_act_new(kanew,ii+i) )*dt2inv
     $              - (  4.d0 * adot_act(k,i)
     $                 + 2.d0 * body_act_new(kjnew,ii+i) )*dtinv
            a3(k) =   12.d0 * (   a_act(k,i)
     $                          - body_act_new(kanew,ii+i))*dt3inv
     $              +  6.d0 * (   adot_act(k,i)
     $                          + body_act_new(kjnew,ii+i))*dt2inv
         ENDDO

         DO k=1,NDIM
            body_pred(k,ii+i)   = body_pred(k,ii+i)   + dt4over24*a2(k)
     $                                                + dt5over120*a3(k)
            body_pred(k+3,ii+i) = body_pred(k+3,ii+i) + dt3over6*a2(k)
     $                                                + dt4over24*a3(k)
         ENDDO

         a1abs    = SQRT(   body_act_new(iaxnew,ii+i)
     $                     *body_act_new(iaxnew,ii+i)
     $                   +  body_act_new(iaynew,ii+i)
     $                     *body_act_new(iaynew,ii+i)
     $                   +  body_act_new(iaznew,ii+i)
     $                     *body_act_new(iaznew,ii+i) )
         adot1abs = SQRT(   body_act_new(ijxnew,ii+i)
     $                     *body_act_new(ijxnew,ii+i)
     $                   +  body_act_new(ijynew,ii+i)
     $                     *body_act_new(ijynew,ii+i)
     $                   +  body_act_new(ijznew,ii+i)
     $                     *body_act_new(ijznew,ii+i))

         DO k=1,NDIM
            a2dot1(k) = a2(k) + dt_tmp*a3(k)
         ENDDO

         a2dot1abs = SQRT( a2dot1(1)*a2dot1(1)
     $                    +a2dot1(2)*a2dot1(2)
     $                    +a2dot1(3)*a2dot1(3))
         a3dot1abs = SQRT( a3(1)*a3(1) + a3(2)*a3(2) + a3(3)*a3(3))

C---  new time step (see Makino&Aarseth, 1992, PASJ, 44, 141)
         dt_new    = SQRT(   eta * (a1abs*a2dot1abs+adot1abs*adot1abs)
     $                     / (adot1abs*a3dot1abs+a2dot1abs*a2dot1abs))


C---  the current time min_t must be an integer multiple of the new time step
C---  that means the new time step can be smaller than or equal to the old time step
C---  for bigger time steps the condition has to be checked and in case it is not 
C---  fulfilled the time step is unchanged (also the new time step is limited to twice
C---  the old time step)

C---  if the new time step is smaller than the old one but not smaller
C---  than dt_min make dt_new a power of two
         IF (dt_new.LT.dt_min) THEN
#ifdef SILENT
            WRITE(0,500) myRank,i+ii,dt_new,dt_min,time_cur
 500        FORMAT('PE',I2.2,': Warning! timestep for particle'
     $              ,I8,' smaller than dt_min',3E14.6)
#endif
            dt_new = dt_min
         ENDIF

         IF ((dt_new.LT.dt_tmp) .AND. (dt_new.GE.dt_min)) THEN
            power  = INT(LOG(dt_new)/LOG(2.d0)) - 1
            dt_tmp = 2.d0**power               
         ENDIF

C---  if the new time step is bigger check integer multiple criteria
C---  also limit to twice the old time step and dt_max
         IF (       (dt_new.GE.2.d0*dt_tmp)
     $        .AND. (dmod(min_t,2.d0*dt_tmp).EQ.0.d0)
     $        .AND. (2.d0*dt_tmp.LE.dt_max)        ) THEN
            dt_tmp = 2.d0*dt_tmp ! twice the old time step is power of two
         ENDIF

C---  set new time step and time for active particle i
         dt_act(i)  = dt_tmp  
         t_act(i)   = min_t


C---  update positions etc of active particle i
         DO k=1,NDIM
            x_act(k,i)    = body_pred(k,ii+i) 
            v_act(k,i)    = body_pred(k+3,ii+i) 
            a_act(k,i)    = body_act_new(iaxnew+k-1,ii+i) 
            adot_act(k,i) = body_act_new(ijxnew+k-1,ii+i)
         ENDDO
         pot_act(i) = body_act_new(ipnew,ii+i)

      ENDDO


      RETURN
      END


C***************************************************************************

      DOUBLE PRECISION FUNCTION dmod(x,y)
      IMPLICIT NONE

      DOUBLE PRECISION x,y

      dmod = (x/y - INT(x/y)) * y

      RETURN
      END

      SUBROUTINE selectactive
C=========================================================================
C===
C===  task:   select all local active particles, ie. all local particles
C===  -----   that need a force-update
C===
C=========================================================================
C===                                                   17/08/2006 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"

C---  local vars
      INTEGER i,k



C---  loop over local particles, select and count active particles
      n_act_loc = 0
      DO i=1,n_loc

         IF ((t_loc(i)+dt_loc(i)).EQ.min_t) THEN  ! set particle active

            n_act_loc                = n_act_loc + 1
            ind_act_loc(n_act_loc)   = i              ! remember local index
            ind_act(n_act_loc)       = ind_loc(i)     ! and global index]
            m_act(n_act_loc)         = m_loc(i)
            h_act(n_act_loc)         = h_loc(i)
            DO k=1,NDIM
               x_act(k,n_act_loc)    = x_loc(k,i)
               v_act(k,n_act_loc)    = v_loc(k,i)
               a_act(k,n_act_loc)    = a_loc(k,i)    
               adot_act(k,n_act_loc) = adot_loc(k,i)    
            ENDDO
            pot_act(n_act_loc)       = pot_loc(i)
            t_act(n_act_loc)         = t_loc(i)
            dt_act(n_act_loc)        = dt_loc(i)
           
         ENDIF
      ENDDO

#ifdef DEBUG
      
      WRITE(STDERR,500) myRank,n_act_loc
 500  FORMAT('PE',I2.2,': selected ',I8,' active particles')
#endif

      RETURN
      END

      SUBROUTINE startmpi
#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'
      INTEGER ierr
        CALL mpi_init(ierr)
#endif
      END 

      SUBROUTINE initmpi
C=========================================================================
C===
C===  task:  initialise MPI and set some common MPI vars, set NOMPI at
C===  -----  compilation to turn off MPI
C===
C=========================================================================
C===                                                   17/08/2006 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"
#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'

C---  local vars
      INTEGER ierr
#endif

      myRank = 0                ! also needed for serial runs
      n_proc = 1

#ifndef NOMPI
C---  start MPI
C          --------

C---  get infos on this run
      CALL MPI_Comm_Rank(MPI_COMM_WORLD,myRank, ierr)
C          -------------
      CALL MPI_Comm_Size(MPI_COMM_WORLD,n_proc, ierr)
C          -------------
      CALL MPI_Get_Processor_Name(processor_name, name_proc, ierr)
C          ----------------------


#ifdef DEBUG
      IF (myRank.EQ.rootRank) THEN
         WRITE(processor_name,'(A20,A)') processor_name,' (root)'
         WRITE(STDERR,'("PE",I2.2,": running on ",A50)') myRank,
     $                                                   processor_name
      ELSE
         WRITE(STDERR,'("PE",I2.2,": running on ",A50)') myRank,
     $                                                   processor_name
      ENDIF
      CALL flush(STDERR)
#endif  

      CALL MPI_Barrier(MPI_COMM_WORLD, ierr)
C          -----------
#endif


      RETURN
      END

      FUNCTION get_index_of_first_particle(id)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER get_index_of_first_particle
      INTEGER id

      get_index_of_first_particle = 0

      END

      FUNCTION get_total_radius(id, r)
      IMPLICIT NONE
#include "src/general.inc"      
      INTEGER get_total_radius
      INTEGER id
      REAL r

      get_total_radius = 0
      END

      FUNCTION new_particle(id, mm, xx, yy, zz, vx, vy, vz, rad)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER new_particle
      INTEGER id, newid, i
      DOUBLE PRECISION mm, rad, xx, yy, zz, vx, vy, vz
    
      newid = 1
      DO i=1,NMAX
         if(myind(i).LT.0) THEN
            newid = i
            exit
         end if
      ENDDO
      N = N + 1
      id = newid
      ind(N)   = N
      myid(N)  = newid
      myind(newid)= N
c      write(*,*) "Adding", id, ind(N), myid(N), myind(newid)
      m(N)     = mm
      x(1,N)   = xx
      x(2,N)   = yy
      x(3,N)   = zz
      v(1,N)   = vx
      v(2,N)   = vy
      v(3,N)   = vz
      h(N)     = rad

      t(N)     = -1.d0
      dt(N)    = -1.d0

      new_particle = 0
      END

      FUNCTION get_total_mass(total_mass)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER get_total_mass
      INTEGER counter
      DOUBLE PRECISION total_mass

      total_mass = 0

      DO counter = 1, N, 1
          total_mass = total_mass + m(counter)
      ENDDO
      
      get_total_mass = 0
      END

      FUNCTION get_index_of_next_particle(id)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER get_index_of_next_particle
      INTEGER id

      get_index_of_next_particle = 0
      END

      FUNCTION set_state(id, mm, xx, yy, zz, vx, vy, vz, rad)
      IMPLICIT NONE
#include "src/general.inc"
   
      INTEGER          id,ip, set_state
      DOUBLE PRECISION mm,xx,yy,zz,vx,vy,vz,rad

C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_state: No such particle exists!'
         set_state = -1
         RETURN 
      ENDIF

      m(ip) = mm
     
      x(1,ip) = xx 
      x(2,ip) = yy
      x(3,ip) = zz
      v(1,ip) = vx
      v(2,ip) = vy
      v(3,ip) = vz
      h(ip) = rad

      set_state = 0

      END

      FUNCTION set_acceleration(id, ax, ay, az)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER set_acceleration
      INTEGER id
      DOUBLE PRECISION ax, ay, az
      
      set_acceleration = -2
      
      END

      FUNCTION get_center_of_mass_position(Cx, Cy, Cz)
      IMPLICIT NONE      
#include "src/general.inc"
      INTEGER get_center_of_mass_position
      INTEGER get_total_mass
      INTEGER counter, ret
      DOUBLE PRECISION Cx, Cy, Cz
      DOUBLE PRECISION total_mass

      ret = get_total_mass(total_mass)

      Cx=0.
      Cy=0.
      Cz=0.
      Cx = 0.0
      Cy = 0.0
      Cz = 0.0

      DO counter = 1, N, 1
          Cx = Cx +m(counter)*x(1,counter)
          Cy = Cy +m(counter)*x(2,counter)
          Cz = Cz +m(counter)*x(3,counter)
      ENDDO

      Cx = Cx/total_mass
      Cy = Cy/total_mass
      Cz = Cz/total_mass

      get_center_of_mass_position = 0
      END

      FUNCTION get_center_of_mass_velocity(Cvx, Cvy, Cvz)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER get_center_of_mass_velocity
      INTEGER get_total_mass
      INTEGER counter, ret
      DOUBLE PRECISION Cvx, Cvy, Cvz
      DOUBLE PRECISION total_mass

      ret = get_total_mass(total_mass)
      
      Cvx = 0.0
      Cvy = 0.0
      Cvz = 0.0

      DO counter = 1, N, 1
          Cvx = Cvx +m(counter)*v(1,counter)
          Cvy = Cvy +m(counter)*v(2,counter)
          Cvz = Cvz +m(counter)*v(3,counter)
      ENDDO

      Cvx = Cvx/total_mass
      Cvy = Cvy/total_mass
      Cvz = Cvz/total_mass

      get_center_of_mass_velocity = 0
      END
      
      

      FUNCTION get_gravity_at_point(eps1, x1, y1, z1, fx, fy, fz, 
     $  number_of_points)
      IMPLICIT NONE
      INTEGER, intent(IN) :: number_of_points
      DOUBLE PRECISION :: eps1(number_of_points), x1(number_of_points)
      DOUBLE PRECISION ::  y1(number_of_points), z1(number_of_points)
      DOUBLE PRECISION :: fx(number_of_points), fy(number_of_points)
      DOUBLE PRECISION :: fz(number_of_points)
      DOUBLE PRECISION p(number_of_points)
      INTEGER get_gravity_at_point
#include "src/general.inc"
         
      CALL amuse_init_grape
      CALL update_grape(1) 
      
      CALL gravity_at_point(time_cur, x1, y1, z1, fx, fy, fz, p,
     $  number_of_points)
      
      CALL amuse_close_grape
        
      get_gravity_at_point = 0
      END
      

      FUNCTION get_potential_at_point(eps1, x1, y1, z1, p,
     $ number_of_points)
      IMPLICIT NONE
      INTEGER, intent(IN) :: number_of_points
      DOUBLE PRECISION :: eps1(number_of_points), x1(number_of_points)
      DOUBLE PRECISION ::  y1(number_of_points), z1(number_of_points)
      DOUBLE PRECISION :: fx(number_of_points), fy(number_of_points)
      DOUBLE PRECISION :: fz(number_of_points)
      DOUBLE PRECISION :: p(number_of_points)
      INTEGER get_potential_at_point   
#include "src/general.inc"  
      
      
      CALL amuse_init_grape
      CALL update_grape(1) 
      
      CALL gravity_at_point(time_cur, x1, y1, z1, fx, fy, fz, p,
     $  number_of_points)
      
      CALL amuse_close_grape

      get_potential_at_point = 0
      END

      FUNCTION get_velocity(id, vxout, vyout, vzout)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER get_velocity
      INTEGER          id,ip
      DOUBLE PRECISION vxout, vyout, vzout
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'get_velocity: No such particle exists',
     $           ' use add_particle'
         get_velocity = -1
         GOTO 999
      ENDIF
      

      vxout = v(1,ip)
      vyout = v(2,ip)
      vzout = v(3,ip)
      get_velocity = 0
      
  999 CONTINUE
      RETURN
      END

      FUNCTION get_position(id, rx, ry, rz)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER id, ip
      INTEGER get_position
      DOUBLE PRECISION rx, ry, rz
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_particle: No such particle exists',
     $           ' use add_particle'
         get_position = -1
         GOTO 999
      ENDIF

      rx = x(1,ip)
      ry = x(2,ip)
      rz = x(3,ip)
      get_position = 0
  999 CONTINUE
      RETURN
      END

      FUNCTION set_velocity(id, vx, vy, vz)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          id,ip, set_velocity
      DOUBLE PRECISION vx,vy,vz


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_particle: No such particle exists',
     $           ' use add_particle'
         set_velocity = -1
         GOTO 999
      ENDIF

C---  setting particle
      v(1,ip) = vx
      v(2,ip) = vy
      v(3,ip) = vz

      set_velocity = 0
 999  CONTINUE
      RETURN
      END


      FUNCTION set_position(id, xx, yy, zz)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          id,ip, set_position
      DOUBLE PRECISION xx,yy,zz


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_particle: No such particle exists',
     $           ' use add_particle'
         set_position = -1
         GOTO 999
      ENDIF

C---  setting particle
      x(1,ip) = xx
      x(2,ip) = yy
      x(3,ip) = zz

      set_position = 0
 999  CONTINUE
      RETURN
      END

      FUNCTION get_acceleration()
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER get_acceleration      
      get_acceleration = -2
      END
            
      FUNCTION add_particle(id,mm,rad,xx,yy,zz,vx,vy,vz)
      IMPLICIT NONE 
#include "src/general.inc"
C---  local vars
      INTEGER          add_particle,id, newid, i
      DOUBLE PRECISION mm,xx,yy,zz,vx,vy,vz,rad
      
      !IF (id.GT.NMAX) THEN
      !   PRINT*, 'id is larger than NMAX which is not allowd!'
      !   add_particle = -1
      !   RETURN 
      !ENDIF
      !IF (myind(id).GE.0) THEN
      !   PRINT*, 'a particle with this id exists already!'
      !   add_particle = -1
      !   RETURN 
      !ENDIF
      newid = 1
      DO i=1,NMAX
         if(myind(i).LT.0) THEN
            newid = i
            exit
         end if
      ENDDO
      
C---  add a particle
      N = N + 1

      ind(N)   = newid
      myid(N)  = newid
      myind(newid)= N
      m(N)     = mm
      x(1,N)   = xx
      x(2,N)   = yy
      x(3,N)   = zz
      v(1,N)   = vx
      v(2,N)   = vy
      v(3,N)   = vz
      h(N)     = rad

      t(N)     = -1.d0
      dt(N)    = -1.d0

c      PRINT*, 'adding particle',m(N),h(N)
c      PRINT*, 'xyz  =',xx,yy,zz
c      PRINT*, 'vxyz =',vx,vy,vz

C---  done
      add_particle = newid

      RETURN
      END

      FUNCTION get_number_of_particles(number_of_particles)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER get_number_of_particles
      INTEGER number_of_particles

      number_of_particles = N
      get_number_of_particles = 0

      END

      FUNCTION get_eps2(ref_eps2)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER get_eps2
      DOUBLE PRECISION ref_eps2
      
      ref_eps2 = eps * eps
      get_eps2 = 0
    
      RETURN
      END


      FUNCTION get_dynamical_time_scale()
      IMPLICIT NONE
#include "src/general.inc"

      DOUBLE PRECISION get_dynamical_time_scale

      IF (inrg.EQ.1) THEN
         get_dynamical_time_scale =  (-0.5d0*MASS*MASS/E_pot)
     $                              / sqrt(2.d0*E_kin/MASS)
           
      ELSE
c         PRINT*, 'Warning: system not initialised yet'
         get_dynamical_time_scale = -1
      ENDIF

      RETURN
      END

      FUNCTION set_dt_max(new_dt_max)
      IMPLICIT NONE
#include "src/general.inc"
      
      INTEGER set_dt_max
      DOUBLE PRECISION new_dt_max
      
      dt_max = new_dt_max

      set_dt_max = 0
      END


      FUNCTION set_eps2(e2)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER set_eps2
      DOUBLE PRECISION e2

      eps     = SQRT(e2)

      set_eps2 = 0
      RETURN
      END

      FUNCTION set_bh_eps(e2)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER set_bh_eps
      DOUBLE PRECISION e2

      bh_eps     = SQRT(e2)

      set_bh_eps = 0
      RETURN
      END


      FUNCTION set_nbh(nbbh)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER nbbh, set_nbh

      nbh     = nbbh

      set_nbh = 0
      RETURN
      END
 
      FUNCTION set_eta(es,e)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER set_eta
      DOUBLE PRECISION es,e

      eta_s   = es
      eta     = e

      set_eta = 0
      END
      
      FUNCTION set_eta_s(value)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER set_eta_s
      DOUBLE PRECISION value

      eta_s   = value

      set_eta_s = 0
      END
      
      FUNCTION set_eta1(value)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER set_eta1
      DOUBLE PRECISION value

      eta   = value

      set_eta1 = 0
      RETURN
      END

      FUNCTION get_eta_s(new_eta_s)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER get_eta_s
      DOUBLE PRECISION new_eta_s

      new_eta_s = eta_s
      get_eta_s   = 0
      END
      
      FUNCTION get_eta(eta_out)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER get_eta
      DOUBLE PRECISION eta_out

      eta_out = eta
      get_eta = 0
      RETURN
      END
      
      FUNCTION get_initialize_once(result_value)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER get_initialize_once, result_value
      
      result_value = g_init_once
      get_initialize_once = 0
      RETURN
      END
      
      FUNCTION set_initialize_once(input_value)
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER set_initialize_once, input_value
      
      IF(g_init_once.EQ.1) THEN
        IF(input_value.EQ.0) THEN
           IF(g_initialized.EQ.1) THEN
                CALL g6_close(clusterid) 
                g_initialized = 0
           ENDIF
        ENDIF
      ENDIF
      
      g_init_once = input_value
      
      set_initialize_once = 0
      
      RETURN
      END
      
      
      SUBROUTINE amuse_init_grape
      IMPLICIT NONE
#include "src/general.inc"

      IF(g_init_once.EQ.1) THEN
        IF(g_initialized.EQ.0) THEN
            CALL initgrape
            g_initialized = 1
        ENDIF
      ELSE
        CALL initgrape
        g_initialized = 1
      ENDIF
      
      END
      
      SUBROUTINE amuse_close_grape
      IMPLICIT NONE
#include "src/general.inc"

      IF(g_init_once.NE.1) THEN
        CALL g6_close(clusterid) 
        g_initialized = 0
      ENDIF
      
      END
C====================================================================
C===
C===  setup_module: function to setup the neccessary things for 
C===                running the module, here
C===
C===                * initialize MPI
C===                * initialize GRAPE
C===                * initialize myid array
C====================================================================
      FUNCTION initialize_code()
      IMPLICIT NONE
#include "src/general.inc"
#include "stopcond.inc"
      INTEGER i,initialize_code
      INTEGER error
      INTEGER mpi_setup_stopping_conditions
      INTEGER set_support_for_condition
    
      error = mpi_setup_stopping_conditions()
      
C     AMUSE STOPPING CONDITION SUPPORT
      error = set_support_for_condition(COLLISION_DETECTION)
      error = set_support_for_condition(NUMBER_OF_STEPS_DETECTION)
      error = set_support_for_condition(TIMEOUT_DETECTION)

      g_init_once = 0
      g_initialized = 0
      
      eta_s   = 0.01
      eta     = 0.02
      time_cur = 0.0
      time_begin = 0.0
C--------------------------------------------------------------------
C---  initialise MPI 
C--------------------------------------------------------------------
      CALL initmpi
C          -------

C--------------------------------------------------------------------
C---  set array to find particles by id to -1
C--------------------------------------------------------------------
      DO i=1,NMAX
         myind(i) = -1
      ENDDO

      initialize_code=0
      RETURN
      END

      FUNCTION commit_particles()
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER is_any_condition_set
      INTEGER commit_particles
      DOUBLE PRECISION time
      INTEGER i

      
C (re)start grape (fip)
C  update local particles on grape
      CALL amuse_init_grape
      CALL update_grape(1) 

      
C---  set some vars
      inrg       = 0

C---  more vars to be set at creating the object
!      dt_max     = .03125d0
      dt_max     = 1.0


C---  more parameters to set
      eps2   = eps*eps
      dt_min = 2.d0**ndtmin   ! set ndtmin in paras.inc


C---  set individual particle times and time steps
      DO i=1,N
         t(i)   = time_cur
         dt(i)  = dt_min
      ENDDO

      n_loc  = N/n_proc         ! set the local number of particles

C---------------------------------------------------------------
C---  distribute body data
C---------------------------------------------------------------
      CALL sendbodydata
C          ------------
      
C--------------------------------------------------------------------
C---  send all particles to GRAPE
C--------------------------------------------------------------------
      CALL sendbodies2grape
C          ----------------

C--------------------------------------------------------------------
C---  select active particles from local particles
C--------------------------------------------------------------------
      min_t = time_cur + dt_min    ! initially all particles have 
      CALL selectactive            ! same time step dt_min
C          ------------

C--------------------------------------------------------------------
C---  predictor (for local active particles)
C--------------------------------------------------------------------
      CALL predictor(1)
C          ---------         

C--------------------------------------------------------------------
C---  gather active particles on all PE's
C--------------------------------------------------------------------
      CALL allgather_ap
C          ------------

C--------------------------------------------------------------------
C---  get local forces on all PE's
C---  (as this is the first call set ifirst to 1 in this call)
C--------------------------------------------------------------------
      CALL gravity(time_cur,1)
C     IF (is_any_condition_set().GT.0) THEN
C         print*, "stopping condition met during commit particles"
C     ENDIF
C          -------

C--------------------------------------------------------------------
C---  sum up the partial forces
C--------------------------------------------------------------------
      CALL sumforces(1)    ! call with 1 bc all forces etc.  need initialisation
C          ---------

C--------------------------------------------------------------------
C---  get individual time steps
C--------------------------------------------------------------------
      CALL timestep(0)
C          --------

C--------------------------------------------------------------------
C---  update GRAPE
C--------------------------------------------------------------------
      CALL update_grape(1)
C          ------------

C--------------------------------------------------------------------
C---  get energy, center of mass and momentum
C--------------------------------------------------------------------
      CALL gatherParts
      CALL energy
C          ------
      E_totini = E_tot          ! set initial value for total energy

      commit_particles = 0

C     close grape before exiting (fip)
      CALL amuse_close_grape

      RETURN
      END

C====================================================================
C===  
C===  
C===  assumes all particles are at the same time time_cur
C====================================================================
      FUNCTION recommit_particles()
      IMPLICIT NONE
#include "src/general.inc"
      
      INTEGER recommit_particles
      INTEGER i,k

C (re)start grape (fip)
C  update local particles on grape
      CALL amuse_init_grape
      CALL update_grape(1) 

C---  set individual particle times and time steps
      DO i=1,N
         t(i)  = time_cur      ! new particles are added at current time
         dt(i) = dt_min        ! with minimum timestep (will change)
         DO k=1,3               ! set acc and jerk to zero
            a(k,i)    = 0.d0
            adot(k,i) = 0.d0
         ENDDO
      ENDDO

      n_loc  = N/n_proc         ! set the local number of particles
  
C--------------------------------------------------------------------
C---  select new particles as active particles
C--------------------------------------------------------------------
      min_t = time_cur + dt_min    ! initially all particles have 
      CALL selectactive            ! same time step dt_min
C          ------------

C--------------------------------------------------------------------
C---  send new particle (marked as active) to  GRAPE
C--------------------------------------------------------------------
      CALL update_grape(0)
C          ------------

C--------------------------------------------------------------------
C---  predictor (for local active particles)
C--------------------------------------------------------------------
      CALL predictor(1)
C          ---------         

C--------------------------------------------------------------------
C---  gather active particles on all PE's
C--------------------------------------------------------------------
      CALL allgather_ap
C          ------------

C--------------------------------------------------------------------
C---  get local forces on all PE's
C---  (as this is the first call set ifirst to 1 in this call)
C--------------------------------------------------------------------
      CALL gravity(time_cur,1)
C          -------

C--------------------------------------------------------------------
C---  sum up the partial forces
C--------------------------------------------------------------------
      CALL sumforces(1)    ! call with 1 bc all forces etc.  need initialisation
C          ---------

C--------------------------------------------------------------------
C---  get individual time steps
C--------------------------------------------------------------------
      CALL timestep(1)
C          --------

C--------------------------------------------------------------------
C---  update GRAPE
C--------------------------------------------------------------------
      CALL update_grape(0)
C          ------------

C--------------------------------------------------------------------
C---  get energy, center of mass and momentum
C--------------------------------------------------------------------
      CALL gatherParts
      CALL energy
C          ------

      recommit_particles = 0

C     close grape before exiting (fip)
      CALL amuse_close_grape

      RETURN
      END


      FUNCTION cleanup_code()      
      IMPLICIT NONE
#include "src/general.inc"

      INTEGER cleanup_code, err, delete_all_particles
#ifndef NOMPI
      INTEGER ierr
#endif

      N=0
      err = delete_all_particles()

C---  just release GRAPE
      IF (g_init_once.EQ.1) THEN
        IF (g_initialized.EQ.1) THEN
            CALL g6_close(clusterid)
            g_initialized = 0
        ENDIF
      ENDIF
C          --------

      cleanup_code = 0
      RETURN
      END
      
      

      FUNCTION delete_all_particles()
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER delete_all_particles,i,k


      delete_all_particles = -1

C---  shift particles after ip to free spot
      DO i=1,N-1
         m(i) = 0.0
         myind(i)= -1
         DO k=1,3
             x(k,i)    = 0.d0
             v(k,i)    = 0.d0
             a(k,i)    = 0.d0
             adot(k,i) = 0.d0
         ENDDO
     
         pot(i)       = 0.d0
         t(i)         = 0.d0
         dt(i)        = dt_min
         ind(i)       = 0
         myid(i)      = 0
      ENDDO
      N        = 0
      n_loc    = 0
      nbh = 0   ! removed particle was BH

      delete_all_particles = 0

      END
      
      
      


      FUNCTION set_particle(id,mm,xx,yy,zz,vx,vy,vz,rad)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          set_particle,id,ip
      DOUBLE PRECISION mm,xx,yy,zz,vx,vy,vz,rad


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_particle: No such particle exists',
     $           ' use add_particle'
         set_particle = -1
         GOTO 999
      ENDIF

C---  setting particle
      m(ip)   = mm
      x(1,ip) = xx
      x(2,ip) = yy
      x(3,ip) = zz
      v(1,ip) = vx
      v(2,ip) = vy
      v(3,ip) = vz
      h(ip)   = rad

      set_particle = 0
 999  CONTINUE
      RETURN
      END


      FUNCTION set_mass(id,mm)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          set_mass,id,ip
      DOUBLE PRECISION mm


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_mass: No such particle exists!'
         set_mass = -1
         GOTO 999
      ENDIF

C---  setting particle
      m(ip)   = mm

      set_mass = 0
 999  CONTINUE
      RETURN
      END

      FUNCTION get_mass(id, value)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          id,ip, get_mass
      DOUBLE PRECISION value


C---  get array address
      ip = myind(id)
      
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'get_mass: No such particle exists!'
         get_mass = -1
         value = 0.d0
      GOTO 999
      ENDIF
      value = m(ip)
      get_mass = 0
 999  CONTINUE
      RETURN
      END

      FUNCTION get_potential(id, value)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          id,ip, get_potential
      DOUBLE PRECISION value


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'get_potential: No such particle exists!'
         get_potential = -1
         RETURN
      ENDIF

      value = pot(ip)
      
      get_potential = 0
      RETURN
      END

      FUNCTION set_radius(id,rad)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          set_radius,id,ip
      DOUBLE PRECISION rad


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_mass: No such particle exists!'
         set_radius = -1
         GOTO 999
      ENDIF

C---  setting particle
      h(ip) = rad

      set_radius = 0
 999  CONTINUE
      RETURN
      END

      FUNCTION get_radius(id, value)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          id,ip
      INTEGER          get_radius
      DOUBLE PRECISION value


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_mass: No such particle exists!'
         get_radius = -1.d0
         GOTO 999
      ENDIF
      get_radius = 0
      value = h(ip)
 999  CONTINUE
      RETURN
      END


      FUNCTION set_pos(id,xx,yy,zz)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          set_pos,id,ip
      DOUBLE PRECISION xx,yy,zz


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_pos: No such particle exists!'
         set_pos = -1
         GOTO 999
      ENDIF

C---  setting particle
      x(1,ip) = xx
      x(2,ip) = yy
      x(3,ip) = zz

      set_pos = 0
 999  CONTINUE
      RETURN
      END


      FUNCTION set_vel(id,vx,vy,vz)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER          set_vel,id,ip
      DOUBLE PRECISION vx,vy,vz


C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'set_vel: No such particle exists!'
         set_vel = -1
         GOTO 999
      ENDIF

C---  setting particle
      v(1,ip) = vx
      v(2,ip) = vy
      v(3,ip) = vz

      set_vel = 0
 999  CONTINUE
      RETURN
      END


      FUNCTION get_time(system_time)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER get_time
      DOUBLE PRECISION system_time

      system_time = time_cur

      get_time = 0

      END

      FUNCTION get_begin_time(system_time)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER get_begin_time
      DOUBLE PRECISION system_time

      system_time = time_begin

      get_begin_time = 0

      END

      FUNCTION set_begin_time(system_time)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER set_begin_time
      DOUBLE PRECISION system_time

      time_begin = system_time

      set_begin_time = 0

      END
      FUNCTION get_time_step(time_step_arg)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER  get_time_step
      DOUBLE PRECISION time_step_arg

C---  get minimum time step from particles
      CALL get_min_t
C          ---------
      time_step_arg = min_t - time_cur
      
      get_time_step = 0
      
      END

      FUNCTION get_kinetic_energy(kinetic_energy)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER get_kinetic_energy
      DOUBLE PRECISION kinetic_energy

      IF (inrg.EQ.1) THEN
          kinetic_energy = E_kin
          get_kinetic_energy = 0
      ELSE
          kinetic_energy = 0.0
          get_kinetic_energy = 0
      ENDIF
        
      END

      FUNCTION get_potential_energy(potential_energy)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER get_potential_energy
      DOUBLE PRECISION potential_energy

      IF (inrg.EQ.1) THEN
          potential_energy = E_pot
          get_potential_energy = 0
      ELSE
          potential_energy = 0.0
          get_potential_energy = 0
      ENDIF

      END

      FUNCTION get_energy_error()
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      DOUBLE PRECISION get_energy_error

      IF (inrg.EQ.1) THEN
         get_energy_error = (E_tot-E_totini)
      ELSE
         get_energy_error = 0.d0
      ENDIF

      RETURN
      END

      FUNCTION get_state(id,mm,xx,yy,zz,vx,vy,vz,rad)
      IMPLICIT NONE 
#include "src/general.inc"
      
      INTEGER          id,ip, get_state
      DOUBLE PRECISION mm,xx,yy,zz,vx,vy,vz,rad

C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'get_state: No such particle exists!'
         get_state = -1
         GOTO 999
      ENDIF

      mm = m(ip)
      xx = x(1,ip)
      yy = x(2,ip)
      zz = x(3,ip)
      vx = v(1,ip)
      vy = v(2,ip)
      vz = v(3,ip)
      rad= h(ip)
      get_state = 0
 999  CONTINUE
      RETURN
      END

      FUNCTION delete_particle(id)
      IMPLICIT NONE 
#include "src/general.inc"

C---  local vars
      INTEGER delete_particle,id,ip,i,k,init
      DOUBLE PRECISION a2by18(NDIM),a1by6(NDIM),aby2(NDIM)


      delete_particle = -1

C---  get array address
      ip = myind(id)
      IF ((ip.LE.0).OR.(ip.GT.NMAX)) THEN
         PRINT*, 'remove_particle: No such particle exists!'
         delete_particle = -1
         RETURN
      ENDIF

c      CALL amuse_init_grape
c      CALL update_grape(1) 

cC---  synchronize system
c      CALL selectsync(time_cur)
cC          ----------
c      CALL sync
cC          ----
cC     close grape before continuing
c      CALL amuse_close_grape

C---  shift particles after ip to free spot
c      write(*,*) "Removing", id, ind(id), myid(ip), myind(id)
      DO i=ip,N-1
         m(i) = m(i+1)
         DO k=1,3
            x(k,i)    = x(k,i+1)
            v(k,i)    = v(k,i+1)
            a(k,i)    = a(k,i+1)
            adot(k,i) = adot(k,i+1)

C---  for shifting particles on GRAPE
c            a2by18(k) = 0.d0 
c            a1by6(k)  = adot(k,i) * over6 
c            aby2(k)   = a(k,i)    * over2

         ENDDO
         pot(i)       = pot(i+1)
         t(i)         = t(i+1)
         dt(i)        = dt(i+1)
         ind(i)       = i
         myid(i)      = myid(i+1)
         myind(myid(i))= i


      ENDDO
      N        = N - 1
      n_loc    = N/n_proc
      IF (ip.LE.nbh) nbh = nbh - 1   ! removed particle was BH
      myind(id) = -1


C---  also delete last particle information on GRAPE which
C---  may interfere with force calculation
      i    = N+1
      m(i) = 0.d0
      DO k=1,3
         x(k,i)    = 0.d0
         v(k,i)    = 0.d0
         a(k,i)    = 0.d0
         adot(k,i) = 0.d0

C---  for shifting particles on GRAPE
         a2by18(k) = 0.d0 
         a1by6(k)  = 0.d0
         aby2(k)   = 0.d0

      ENDDO
      pot(i)       = 0.d0
      t(i)         = 0.d0
      dt(i)        = dt_min
      ind(i)       = 0
      myid(i)      = 0

C      CALL g6_set_j_particle(clusterid, i-1, ind(i),t(i),
C     $                       dt(i),m(i),a2by18,a1by6,aby2,
C     $                       v(1,i), x(1,i))


C skip at the moment: should it be called afterwards? (fip)
C---  recompute forces and time steps for all particles
C      init = reinitialize_particles() 
C            ----------------------

      delete_particle = 0

      END



 
      FUNCTION evolve_model(tend)
C---  isync removed      
      IMPLICIT NONE 
#include "src/general.inc"
#include "stopcond.inc"
C---  local vars
      INTEGER          evolve_model
      DOUBLE PRECISION tend

      INTEGER clock_init, clock_current
      INTEGER count_rate, count_max
      INTEGER is_any_condition_set
      INTEGER is_stopping_condition_enabled
      INTEGER is_number_of_steps_detection_enabled
      INTEGER is_timeout_detection_enabled
      INTEGER mpi_distribute_stopping_conditions
      INTEGER mpi_collect_stopping_conditions
      
      INTEGER get_stopping_condition_number_of_steps_parameter 
      INTEGER get_stopping_condition_timeout_parameter 
      INTEGER max_number_of_steps
      DOUBLE PRECISION timeout
      INTEGER number_of_steps_innerloop
      INTEGER next_index_for_stopping_condition
      INTEGER set_stopping_condition_info
      INTEGER stopping_index
      INTEGER reset_stopping_conditions, error
C (re)start grape (fip)
C  update local particles on grape
      CALL amuse_init_grape
      CALL update_grape(1) 

      t_end      = tend

      error = reset_stopping_conditions()
      number_of_steps_innerloop = 0

C--------------------------------------------------------------------
C---  main loop begins here
C--------------------------------------------------------------------
      CALL SYSTEM_CLOCK(clock_init, count_rate, count_max)
    
      error = mpi_distribute_stopping_conditions()
      
      error = is_stopping_condition_enabled(
     $               NUMBER_OF_STEPS_DETECTION, 
     $               is_number_of_steps_detection_enabled)
      error = is_stopping_condition_enabled(
     $               TIMEOUT_DETECTION,
     $               is_timeout_detection_enabled)
      error = get_stopping_condition_number_of_steps_parameter(
     $               max_number_of_steps)
      error = get_stopping_condition_timeout_parameter(
     $               timeout)

      

 100  IF (time_cur.GE.t_end) GOTO 900

C--- obsolete, use stopcond library instead..
         icollision  = -1       ! no collision yet
         idprimary   = -1       ! hence no ids for
         idsecondary = -1       ! collided particles

C---------------------------------------------------------------
C---  get the global minimum timestep 
C---------------------------------------------------------------
         CALL get_min_t
C             ---------

C--------------------------------------------------------------------
C---  select active particles from local particles
C--------------------------------------------------------------------
         CALL selectactive
C             ------------

C--------------------------------------------------------------------
C---  predictor (for local active particles)
C--------------------------------------------------------------------
         CALL predictor(0)
C             ---------         

C--------------------------------------------------------------------
C---  gather active particles on all PE's
C--------------------------------------------------------------------
         CALL allgather_ap
C             ------------

C--------------------------------------------------------------------
C---  get local forces on all PE's
C---  (as this is not the first call set ifirst to 0 in this call)
C--------------------------------------------------------------------
         CALL gravity(min_t,0)
C             -------

C--------------------------------------------------------------------
C---  sum up the partial forces
C--------------------------------------------------------------------
         CALL sumforces(0)      ! call with 0; just sum forces
C             ---------

C--------------------------------------------------------------------
C---  make the corrector step
C---  this also updates the time steps of active particles
C--------------------------------------------------------------------
         CALL corrector
C             ---------

C--------------------------------------------------------------------
C---  update local particles from local active particles
C--------------------------------------------------------------------
         CALL update_loc_p
C             ------------

C--------------------------------------------------------------------
C---  also update local particles on GRAPE from local active particles
C--------------------------------------------------------------------
         CALL update_grape(0)
C             ------------
      
         time_cur   = min_t

C timeout and number of steps detection goes here i quess...

         IF (is_number_of_steps_detection_enabled.GT.0) THEN
             number_of_steps_innerloop = 
     $           number_of_steps_innerloop + 1
             IF (number_of_steps_innerloop.GT.max_number_of_steps) THEN
                 stopping_index = next_index_for_stopping_condition()
                 error = set_stopping_condition_info(stopping_index, 
     $                       NUMBER_OF_STEPS_DETECTION);
             ENDIF

         ENDIF

         IF (is_timeout_detection_enabled.GT.0) THEN
             CALL SYSTEM_CLOCK(clock_current, count_rate, count_max)
             IF ((clock_current-clock_init).GT.timeout) THEN
                 stopping_index = next_index_for_stopping_condition()
                 error = set_stopping_condition_info(stopping_index,
     $                       TIMEOUT_DETECTION)
             ENDIF
         ENDIF
    
C---         CALL gather_collisions
         error = mpi_collect_stopping_conditions()
        
C---  break if collision occured
C--      IF (icollision.EQ.1) GOTO 900
         IF (is_any_condition_set().GT.0) GOTO 900
         GOTO 100   
 900  CONTINUE                  ! end of main loop

C----------------------------------

C----------------------------------
C---  synchronize system if flag is set
C--------------------------------------------------------------------

C-- Only synchronize_model if the user asked for it!
C      IF (isync.EQ.1) THEN
C
C         CALL selectsync(time_cur)
C             ----------
C         CALL sync
C             ----
C      ENDIF

      CALL gatherParts
C--------------------------------------------------------------------
C---  get energy, center of mass and momentum
C--------------------------------------------------------------------
      CALL energy
C          ------

C cello      evolve = idprimary        ! return primary collision member or -1

      
C     close grape before exiting (fip)
      CALL amuse_close_grape

      evolve_model = 0

      END

      FUNCTION synchronize_model()
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER synchronize_model
    
      CALL amuse_init_grape
      CALL update_grape(1) 
      
      CALL selectsync(time_cur)
      
      CALL sync

      CALL gatherParts
      
      CALL energy
      
      synchronize_model = 0
      
      CALL amuse_close_grape


      END


      FUNCTION find_colliding_primary()
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER  find_colliding_primary

      find_colliding_primary = idprimary

      RETURN
      END

      FUNCTION find_colliding_secondary(id1)
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER  find_colliding_secondary,id1,idummy
      
      idummy = id1

      find_colliding_secondary = idsecondary

      RETURN
      END


       SUBROUTINE gather_collisions
#include "src/general.inc"
#ifndef NOMPI
#include <mpif.h>
       INCLUDE "mpi.inc"       
       
       integer cflag(NPEMAX),id1(NPEMAX),id2(NPEMAX),ierr
              
       CALL MPI_AllGather(icollision,1,MPI_INTEGER, cflag, 1, 
     &       MPI_INTEGER,MPI_COMM_WORLD,ierr)
       CALL MPI_AllGather(idprimary,1,MPI_INTEGER, id1, 1, 
     &       MPI_INTEGER,MPI_COMM_WORLD,ierr)
       CALL MPI_AllGather(idsecondary,1,MPI_INTEGER, id2, 1, 
     &       MPI_INTEGER,MPI_COMM_WORLD,ierr)
       
       icollision=-1
         DO i=1,n_proc
           IF(cflag(i).EQ.1) THEN
             icollision=cflag(i)
             idprimary=id1(i)
             idsecondary=id2(i)
             exit             
           ENDIF        
         ENDDO
         
#endif              
       END
       
      FUNCTION commit_parameters()
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER  commit_parameters
      commit_parameters = 0
      time_cur = time_begin
      IF(g_init_once.EQ.1) THEN
        IF(g_initialized.EQ.0) THEN
            CALL initgrape
            g_initialized = 1
        ENDIF
      ENDIF
      
      END
      
      FUNCTION recommit_parameters()
      IMPLICIT NONE
#include "src/general.inc"
      INTEGER  recommit_parameters
      recommit_parameters = 0
      END
      
      

      SUBROUTINE writebh(time,ipred)
C=========================================================================
C===
C===  task: write detailed output for BHs at given time, ipred=1 
C===  ----- BH data is predicted if t_BH!=time and ipred=1
C===
C=========================================================================
      IMPLICIT NONE
#include "general.inc"

      INTEGER          ipred,i,k
      DOUBLE PRECISION time
      DOUBLE PRECISION dtbh(NBHMAX),xbh(NDIM,NBHMAX),vbh(NDIM,NBHMAX),
     $                 dt2half,dt3over6

C---  get current time difference of BHs
      IF (ipred.EQ.1) THEN 

         DO i=1,nbh
            dtbh(i) = time - t_loc(i)       ! can use t_loc() here because
                                            ! there are only a few BH particles
                                            ! that always should be local on root

C---  predict BH at current time
            dt2half  = 0.5d0 * dtbh(i)*dtbh(i)
            dt3over6 = dtbh(i)*dt2half / 3.d0

            DO k=1,3
               xbh(k,i) = x_loc(k,i) + v_loc(k,i)*dtbh(i)
     $                               + a_loc(k,i)*dt2half
     $                               + adot_loc(k,i)*dt3over6
               vbh(k,i) = v_loc(k,i) + a_loc(k,i)*dtbh(i)
     $                               + adot_loc(k,i)*dt2half

            ENDDO
         ENDDO
      ELSE

C---  just copy current position
         DO i=1,nbh
            DO k=1,3
               xbh(k,i) = x_loc(k,i)
               vbh(k,i) = v_loc(k,i)
            ENDDO
         ENDDO

      ENDIF

      DO i=1,nbh
         WRITE(ubh,504) ind_loc(i)-1,time,m_loc(i),
     $                 (xbh(k,i),k=1,3),(vbh(k,i),k=1,3)
      ENDDO
 504  FORMAT(I10.10,1P,E15.6,2X,E15.6,2X,3E14.6,2X,3E14.6)

      CALL flush(ubh)

      RETURN
      END

      SUBROUTINE sendbodies2grape
C===  init the local GRAPE's
      IMPLICIT NONE
#include "general.inc"

C---  local vars
      INTEGER          j,k
      DOUBLE PRECISION a2by18(NDIM),a1by6(NDIM),aby2(NDIM)

C---  initial load the particles to the local GRAPE's 
      DO k=1,NDIM
         a2by18(k) = 0.d0
         a1by6(k)  = 0.d0 
         aby2(k)   = 0.d0
      ENDDO

      
      DO j=nbh+1,n_loc         

C---  in case of a restart acceleration and jerk are known
         IF (irestart.EQ.1) THEN
            DO k=1,NDIM
               a1by6(k)  = adot_loc(k,j)*over6 
               aby2(k)   = a_loc(k,j)*over2
            ENDDO
         ENDIF

         CALL g6_set_j_particle(clusterid, j-1-nbh, ind_loc(j), 
     $        t_loc(j), 
     $        dt_loc(j),m_loc(j),a2by18(1),a1by6(1), 
     $        aby2(1),v_loc(1,j), x_loc(1,j))
         
      ENDDO

#ifdef DEBUG
      WRITE(STDERR,600) myRank,n_loc
 600  FORMAT('PE',I2.2,':',I10,' particles loaded to local GRAPE')
      CALL flush(STDERR)
#endif

      RETURN
      END

      SUBROUTINE cmcorr(N,m,x,v)
      IMPLICIT NONE

C---  input vars
      INTEGER N,NDIM
      PARAMETER (NDIM=3)
      DOUBLE PRECISION m(N),x(NDIM,N),v(NDIM,N)

C---  local vars
      INTEGER          i,k
      DOUBLE PRECISION mcm,xcm(NDIM),vcm(NDIM)


C---  init local vars
      mcm = 0.d0
      DO k=1,NDIM
         xcm(k) = 0.d0
         vcm(k) = 0.d0
      ENDDO


C---  sum mass weighted positions and velocities
      DO i=1,N
         mcm = mcm + m(i)
         DO k=1,NDIM
            xcm(k) = xcm(k) + m(i)*x(k,i)
            vcm(k) = vcm(k) + m(i)*v(k,i)
         ENDDO
      ENDDO


C---  get cm data
      DO k=1,NDIM
         xcm(k) = xcm(k)/mcm
         vcm(k) = vcm(k)/mcm
      ENDDO


C---  set cm to origin 
      DO i=1,N
         mcm = mcm + m(i)
         DO k=1,NDIM
            x(k,i) = x(k,i) - xcm(k)
            v(k,i) = v(k,i) - vcm(k)
         ENDDO
      ENDDO

#ifdef DEBUG
      WRITE(0,*) 'corrected body data for center of mass'
      WRITE(0,*) 'xcm = ', xcm 
      WRITE(0,*) 'xcm = ', xcm 
      CALL flush(0)
C          -----
#endif

      RETURN
      END

      SUBROUTINE sync
C===  particles previouisly selected are sync'd by a full GRAPE integration
      IMPLICIT NONE
#include "general.inc"
      
      INTEGER          i,power
      DOUBLE PRECISION dtcmax,ttmp

!      IF (n_act_loc.LE.0) RETURN ! no sync'ing needed
      IF (time_cur.EQ.0) RETURN 
      ! no syncing needed, for ticket #147
      ! log(0) is infinity and power fails

C--------------------------------------------------------------------
C---  predictor (for local active particles)
C--------------------------------------------------------------------
         CALL predictor(0)
C             ---------         

C--------------------------------------------------------------------
C---  gather active particles on all PE's
C--------------------------------------------------------------------
         CALL allgather_ap
C             ------------

C--------------------------------------------------------------------
C---  get local forces on all PE's
C---  (as this is not the first call set ifirst to 0 in this call)
C--------------------------------------------------------------------
         CALL gravity(time_cur,0)
C             -------

C--------------------------------------------------------------------
C---  sum up the partial forces
C--------------------------------------------------------------------
         CALL sumforces(0)      ! call with 0; just sum forces
C             ---------

C--------------------------------------------------------------------
C---  make the corrector step
C---  this also updates the time steps of active particles
C--------------------------------------------------------------------
         CALL corrector
C             ---------


C--------------------------------------------------------------------
C---  need to correct time step to a power of two value
C--------------------------------------------------------------------

C---  first get maximal allowed time step wrt to current time
         ttmp = time_cur
 100     CONTINUE
            power     = INT(LOG(ttmp)/LOG(2.d0))
            dtcmax    = 2.d0**power
            IF (dtcmax.GT.ttmp) dtcmax = dtcmax/2.d0
            ttmp = dmod(time_cur,dtcmax)
         IF (ttmp.GT.0.d0) GOTO 100

C---  now correct individual time step to powers of two or dtcmax
         DO i=1,n_act_loc

            power     = INT(LOG(dt_act(i))/LOG(2.d0)) - 1
            dt_act(i) = MIN(2.d0**power, dtcmax)

         ENDDO
 
C--------------------------------------------------------------------
C---  update local particles from local active particles
C--------------------------------------------------------------------
         CALL update_loc_p
C             ------------

C--------------------------------------------------------------------
C---  also update local particles on GRAPE from local active particles
C--------------------------------------------------------------------
         CALL update_grape(0)
C             ------------


      RETURN
      END

      subroutine gatherParts
#include "general.inc"      
#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'

            CALL MPI_Gather(m_loc,   n_loc, MPI_DOUBLE_PRECISION, 
     $						m,   n_loc, MPI_DOUBLE_PRECISION, 
     $                      rootRank, MPI_COMM_WORLD,ierr)
            CALL MPI_Gather(t_loc,   n_loc, MPI_DOUBLE_PRECISION,
     $                      t,   n_loc, MPI_DOUBLE_PRECISION, 
     $                      rootRank, MPI_COMM_WORLD,ierr)
            CALL MPI_Gather(dt_loc,  n_loc, MPI_DOUBLE_PRECISION,
     $                      dt,  n_loc, MPI_DOUBLE_PRECISION, 
     $                      rootRank, MPI_COMM_WORLD,ierr)
            CALL MPI_Gather(x_loc, 3*n_loc, MPI_DOUBLE_PRECISION, 
     $                      x, 3*n_loc, MPI_DOUBLE_PRECISION, 
     $                      rootRank, MPI_COMM_WORLD,ierr)
            CALL MPI_Gather(v_loc, 3*n_loc, MPI_DOUBLE_PRECISION, 
     $                      v, 3*n_loc,MPI_DOUBLE_PRECISION, 
     $                      rootRank, MPI_COMM_WORLD,ierr)
            CALL MPI_Gather(pot_loc, n_loc, MPI_DOUBLE_PRECISION,
     $                      pot, n_loc, MPI_DOUBLE_PRECISION, 
     $                      rootRank, MPI_COMM_WORLD,ierr)
            CALL MPI_Gather(a_loc, 3*n_loc, MPI_DOUBLE_PRECISION, 
     $                      a, 3*n_loc,MPI_DOUBLE_PRECISION, 
     $                      rootRank, MPI_COMM_WORLD,ierr)
            CALL MPI_Gather(adot_loc, 3*n_loc, MPI_DOUBLE_PRECISION,
     $                      adot, 3*n_loc,MPI_DOUBLE_PRECISION, 
     $                      rootRank, MPI_COMM_WORLD,ierr)
#endif

      end subroutine

      SUBROUTINE energy
C=========================================================================
C===
C===  task: compute energies, angular momentum and center of mass
C===  -----
C===
C=========================================================================
C===                                                   17/08/2006 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"
C---  local vars
      INTEGER          i,k,k3,ip
      DOUBLE PRECISION mcm,dttmp,dt2half,dt3over6,
     $                 xx,xy,xz,vx,vy,vz

C---  an extra force calculation to get the predicted potential
      CALL predict_potential(time_cur)
C          -----------------

C---  copy potential only 
      DO i=1,n_act
          ip      = ind_act(i)
          pot(ip) = body_act_new(ipnew,i)
      ENDDO

      dttmp = 0.
C---  predict to current time
C---  (for all particles, dt may be zero in which case current pos
C---  and velocities are just copied)
      DO i=1,N
         
         dttmp    = time_cur - t(i)
         dt2half  = 0.5d0 * dttmp * dttmp
         dt3over6 = dttmp * dt2half / 3.d0

         DO k=1,3
            k3 = k + 3
            body_pred_loc(k,i)  = x(k,i) + v(k,i)*dttmp  
     $                                   + a(k,i)*dt2half
     $                                   + adot(k,i)*dt3over6
            body_pred_loc(k3,i) = v(k,i) + a(k,i)*dttmp
     $                                   + adot(k,i)*dt2half

         ENDDO


      ENDDO

C---  get potential and kinetic energy
      E_pot = 0.d0
      E_kin = 0.d0
      DO i=1,N
         vx    = body_pred_loc(4,i)
         vy    = body_pred_loc(5,i)
         vz    = body_pred_loc(6,i)
         E_pot = E_pot + m(i)*pot(i)
         E_kin = E_kin + m(i)*( vx*vx + vy*vy + vz*vz )
      ENDDO
      E_pot = 0.5d0 * E_pot
      E_kin = 0.5d0 * E_kin
      E_tot = E_kin + E_pot


C---  get center of mass
      mcm = 0.d0
      DO k=1,NDIM
         xcm(k) = 0.d0
         vcm(k) = 0.d0
      ENDDO

      DO i=1,N
         mcm    = mcm + m(i)
         xx     = body_pred_loc(1,i)
         xy     = body_pred_loc(2,i)
         xz     = body_pred_loc(3,i)
         vx     = body_pred_loc(4,i)
         vy     = body_pred_loc(5,i)
         vz     = body_pred_loc(6,i)
         xcm(1) = xcm(1) + m(i)*xx
         xcm(2) = xcm(2) + m(i)*xy
         xcm(3) = xcm(3) + m(i)*xz
         vcm(1) = vcm(1) + m(i)*vx
         vcm(2) = vcm(2) + m(i)*vy
         vcm(3) = vcm(3) + m(i)*vz
      ENDDO

      DO k=1,NDIM
         xcm(k) = xcm(k)/mcm
         vcm(k) = vcm(k)/mcm
      ENDDO
      MASS = mcm

C---  get angular momentum
      DO k=1,NDIM
         mom(k) = 0.d0
      ENDDO
      
      DO i=1,N
         xx     = body_pred_loc(1,i)
         xy     = body_pred_loc(2,i)
         xz     = body_pred_loc(3,i)
         vx     = body_pred_loc(4,i)
         vy     = body_pred_loc(5,i)
         vz     = body_pred_loc(6,i)
         mom(1) = mom(1) + m(i) * ( xy*vz - xz*vy )
         mom(2) = mom(2) + m(i) * ( xz*vx - xx*vz )
         mom(3) = mom(3) + m(i) * ( xx*vy - xy*vx )
      ENDDO
     
      inrg = 1

       
      RETURN
      END

      SUBROUTINE predictor(imode)
C=========================================================================
C===  predict active particles
C===
C===    imode = 0 true prediction
C===          = 1 no prediction, just copy current pos and vel
C=========================================================================
      IMPLICIT NONE
#include "general.inc"
      
C---  local vars
      INTEGER i,k,k3,imode
      DOUBLE PRECISION dt2half,dt3over6

C---  dont do anything if none of the local particles are active
      IF (n_act_loc.LT.1) RETURN

      IF (imode.NE.1) THEN

         DO i=1,n_act_loc
         
            dt2half  = 0.5d0 * dt_act(i) * dt_act(i)
            dt3over6 = dt_act(i) * dt2half / 3.d0

            DO k=1,3
               k3 = k + 3
               body_pred_loc(k,i)  = x_act(k,i) + v_act(k,i)*dt_act(i)  
     $                                          + a_act(k,i)*dt2half
     $                                          + adot_act(k,i)*dt3over6
               body_pred_loc(k3,i) = v_act(k,i) + a_act(k,i)*dt_act(i)
     $                                          + adot_act(k,i)*dt2half

            ENDDO

         ENDDO

      ELSE

         DO i=1,n_act_loc
            DO k=1,NDIM
               body_pred_loc(k,i)   = x_act(k,i) ! set x_act_new and v_act_new here
               body_pred_loc(k+3,i) = v_act(k,i) ! since predictor is not called
            ENDDO
         ENDDO

      ENDIF



      RETURN
      END

      SUBROUTINE initpars
C=========================================================================
C===  
C===  task:  initialise some parameters
C===  -----
C===
C=========================================================================
C===                                                   17/08/2006 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"

      INTEGER i

C---  softening
      eps2   = eps*eps

C---  set minimum and maximum time step
      dt_min = 2.d0**ndtmin   ! set ndtmin in paras.inc

      dt_max = MIN(dt_disk,   dt_max)   ! dt_max is limited by output interval
      dt_max = MIN(dt_contr,  dt_max)   ! to make sure system is in sync at output

      dt_restart = MAX(dt_restart, 2.d0*dt_disk) ! make sure restart file is not written
                                                 ! more frequently than very other snapshot

C---  set individual particle times and time steps
      IF (irestart.NE.1) THEN
         DO i=1,N
            t(i)   = time_cur
            dt(i)  = dt_min
         ENDDO
      ENDIF

      n_loc = N/n_proc          ! set the local number of particles
                                ! n_proc is set to 1 in serial runs

C---  set times for output
      IF (irestart.NE.1) THEN
         t_timing  = time_cur + dt_timing
         t_disk    = time_cur + dt_disk 
         t_contr   = time_cur + dt_contr
         t_bh      = time_cur + dt_bh
         t_restart = time_cur + dt_restart

         Timesteps = 0

      ENDIF

      RETURN
      END

       subroutine start_viewer
#ifndef NOMPI
#include "general.inc"
       if(myRank.EQ.rootRank) then
#endif
        print*,myRank,rootRank
        call viewer
#ifndef NOMPI
       endif
#endif
       end subroutine

      SUBROUTINE sumforces(ifirst)
C=========================================================================
C===
C===  task:  using allreduce sum up all the partial local forces
C===  -----
C===
C=========================================================================
      IMPLICIT NONE

C---  input vars
      INTEGER ifirst,i,ip

#include "general.inc"
#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'

C---  local vars
      INTEGER ierr
#endif
#ifdef NOMPI
C---  equivalence here!!!
#endif

      IF (ifirst.EQ.1) THEN     ! initial force calculation

#ifndef NOMPI
C--------------------------------------------------------------------
C---  collect all forces on root and then scatter to all PE's
C--------------------------------------------------------------------
         CALL MPI_Reduce(body_act_tmp, body_act_new, 7*n_act,
     $                   MPI_DOUBLE_PRECISION, 
     $                   MPI_SUM, rootRank, MPI_COMM_WORLD,ierr)
         IF (myRank.EQ.rootRank) THEN
            DO i=1,n_act        ! copy forces etc. to main arrays
               pot(i)    = body_act_new(ipnew,i)
               a(1,i)    = body_act_new(iaxnew,i)
               a(2,i)    = body_act_new(iaynew,i)
               a(3,i)    = body_act_new(iaznew,i)
               adot(1,i) = body_act_new(ijxnew,i)
               adot(2,i) = body_act_new(ijynew,i)
               adot(3,i) = body_act_new(ijznew,i)
            ENDDO
         ENDIF
          
         CALL MPI_Scatter(pot,    n_loc, MPI_DOUBLE_PRECISION, 
     $                    pot_loc,    n_loc,
     $                    MPI_DOUBLE_PRECISION, rootRank, 
     $                    MPI_COMM_WORLD,ierr)
         CALL MPI_Scatter(a,    3*n_loc, MPI_DOUBLE_PRECISION, 
     $                    a_loc,    3*n_loc,
     $                    MPI_DOUBLE_PRECISION, rootRank, 
     $                    MPI_COMM_WORLD,ierr)
         CALL MPI_Scatter(adot, 3*n_loc, MPI_DOUBLE_PRECISION,
     $                    adot_loc, 3*n_loc,
     $                    MPI_DOUBLE_PRECISION, rootRank, 
     $                    MPI_COMM_WORLD,ierr)

         CALL MPI_Barrier(MPI_COMM_WORLD, ierr)
C             -----------
#endif
#ifdef NOMPI
         DO i=1,n_act           ! just copy forces etc., *_loc is set by EQUIVALENCE
            ip         = ind_act_loc(i)
            pot(ip)    = body_act_tmp(ipnew,i)
            a(1,ip)    = body_act_tmp(iaxnew,i)
            a(2,ip)    = body_act_tmp(iaynew,i)
            a(3,ip)    = body_act_tmp(iaznew,i)
            adot(1,ip) = body_act_tmp(ijxnew,i)
            adot(2,ip) = body_act_tmp(ijynew,i)
            adot(3,ip) = body_act_tmp(ijznew,i)
         ENDDO
#endif

      ELSE                      ! after force calculation in main loop

#ifndef NOMPI         
C---  Reduce the "global" vectors from "local" 
         CALL MPI_Allreduce(body_act_tmp, body_act_new, 7*n_act,
     $                      MPI_DOUBLE_PRECISION, MPI_SUM,
     $                      MPI_COMM_WORLD, ierr)
#endif


      ENDIF

      RETURN
      END

      SUBROUTINE readbodydata
      IMPLICIT NONE
#include "general.inc"
#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'
      INTEGER ierr
#endif

C---  local vars
      INTEGER i,j

C--------------------------------------------------------------------
C---  read the global data for particles to the rootRank
C--------------------------------------------------------------------         
      IF (myRank.EQ.rootRank) THEN 
         OPEN(11, FILE=inp_fname)
      
         READ(11,*) diskstep
         READ(11,*) N
         READ(11,*) time_cur
      
         DO i=1,N
            READ(11,*) ind(i), m(i), (x(j,i),j=1,3), (v(j,i),j=1,3)
            ind(i) = ind(i) + 1 ! shift index by one
         ENDDO

         CLOSE(11)

#ifndef SILENT
         WRITE(STDOUT,*) N,' particles have been read at t =',time_cur
         CALL flush(STDOUT)
#endif
      ENDIF

C---  need to broadcast N and time_cur
#ifndef NOMPI
      CALL MPI_Bcast(N,        1, MPI_INTEGER,    rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(time_cur, 1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)
#endif
      
      RETURN
      END

      SUBROUTINE sendinpdata
C=========================================================================
C===
C===  task: broadcast necessary data to all nodes and scatter 
C===  ----- nbody data
C===
C=========================================================================
C===                                                   17/08/2006 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"
#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'

C---  local vars
      INTEGER ierr

C--------------------------------------------------------------------
C---  distribute the data to all processes
C--------------------------------------------------------------------

C---  Broadcast all useful values to all processors... 
      CALL MPI_Bcast(eps,      1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(t_end,    1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)

      CALL MPI_Bcast(eta,      1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(eta_s,    1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)

      CALL MPI_Bcast(dt_max,   1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(dt_disk,  1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(dt_contr, 1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(dt_bh,    1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(dt_restart, 1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)

      CALL MPI_Bcast(nbh,      1, MPI_INTEGER,    rootRank,
     $                                        MPI_COMM_WORLD,ierr)

      CALL MPI_Bcast(irestart, 1, MPI_INTEGER,    rootRank,
     $                                        MPI_COMM_WORLD,ierr)


#ifdef DEBUG
       WRITE(STDERR,600) myRank
 600   FORMAT (' PE',I2.2,': input data broadcasted ')
#endif

#endif

      RETURN
      END

      SUBROUTINE selectsync(tnow)
C=========================================================================
C===
C===  task:   select particles that need to be sync'd from a list of 
C===  -----   indices
C===
C=========================================================================
C===                                                   09/01/2007 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"

C---  input parameters
      DOUBLE PRECISION tnow

C---  local vars
      INTEGER i,k

C---  loop over local particles, select and count active particles
      n_act_loc=0 
      DO i=1,n_loc


         IF (t_loc(i).LT.tnow) THEN ! particle needs to be sync'd


            n_act_loc                = n_act_loc + 1
            ind_act_loc(n_act_loc)   = i              ! remember local index
            
            ind_act(n_act_loc)       = ind_loc(i)     ! and global index
            m_act(n_act_loc)         = m_loc(i)
            h_act(n_act_loc)         = h_loc(i)
            DO k=1,NDIM
               x_act(k,n_act_loc)    = x_loc(k,i)
               v_act(k,n_act_loc)    = v_loc(k,i)
               a_act(k,n_act_loc)    = a_loc(k,i)    
               adot_act(k,n_act_loc) = adot_loc(k,i)    
            ENDDO
            pot_act(n_act_loc)       = pot_loc(i)
            t_act(n_act_loc)         = t_loc(i)
            dt_act(n_act_loc)        = tnow - t_loc(i) ! set time step to reach tnow
           
         ENDIF
      ENDDO

#ifdef DEBUG
      
      WRITE(STDERR,500) myRank,n_act_loc
 500  FORMAT('PE',I2.2,': selected ',I8,' particles to sync')
#endif

      RETURN
      END

      SUBROUTINE allgather_ap
C=========================================================================
C===
C===  task:  collect predicted positions and velocities of active  
C===  -----  particles from all nodes on root, then redistribute so that 
C===         all nodes know all active particles
C===
C=========================================================================
      IMPLICIT NONE
#include "general.inc"


#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'
      INTEGER i,ierr
#endif

C---  first get information about how many active particles are on each node         
      disp_act_v(1)  = 0           ! these two values are needed also in 
      disp3_act_v(1) = 0           ! the serial run (NOMPI)

#ifndef NOMPI
C---  collect all n_act_loc in one array n_act_v
      CALL MPI_Allgather(n_act_loc, 1,MPI_INTEGER, n_act_v, 1, 
     $                   MPI_INTEGER,MPI_COMM_WORLD,ierr)
      
      
      DO i=1,n_proc
         n3_act_v(i) = 6*n_act_v(i)      ! 16 is the length of one particle
      ENDDO                               ! data set in the body_act array
    
C---  get a displacement vector so that all vectors can be connected seamless
C---  also get total number of active particles
      n_act          = n_act_v(1)
      DO i=2,n_proc

         disp_act_v(i)  = disp_act_v(i-1) + n_act_v(i-1)
         disp3_act_v(i) = disp3_act_v(i-1) + n3_act_v(i-1)
         n_act          = n_act + n_act_v(i)
         
      ENDDO
      
C---  allgather global indices of all active particles
C---  NOTE: Gatherv + Bcast is equivalent to Allgatherv but no extra 
C---        memory is needed 
      if(myRank .eq. rootRank) then
      
        CALL MPI_Gatherv(MPI_IN_PLACE, n_act_loc,MPI_INTEGER, ind_act,
     $                 n_act_v,
     $                 disp_act_v, MPI_INTEGER,rootRank,
     $                                           MPI_COMM_WORLD,ierr)
      else       
        CALL MPI_Gatherv(ind_act, n_act_loc, MPI_INTEGER, ind_act,
     $                  n_act_v,disp_act_v, MPI_INTEGER,rootRank,
     $                                           MPI_COMM_WORLD,ierr)
      endif
      
      
    
      CALL MPI_Bcast(ind_act, n_act, MPI_INTEGER, rootRank,
     $                                           MPI_COMM_WORLD,ierr)

C---  allgather the predicted positions and velocities of active particles
      CALL MPI_Allgatherv(body_pred_loc, 6*n_act_loc, 
     $                    MPI_DOUBLE_PRECISION, body_pred, n3_act_v,
     $                    disp3_act_v, MPI_DOUBLE_PRECISION,
     $                    MPI_COMM_WORLD,ierr)

      
    
     
      if(myRank .eq. rootRank) then
      CALL MPI_Gatherv(MPI_IN_PLACE, n_act_loc, MPI_DOUBLE_PRECISION,
     $                 h_act, 
     $                 n_act_v, disp_act_v, MPI_DOUBLE_PRECISION,
     $                 rootRank,MPI_COMM_WORLD,ierr)
      else
      CALL MPI_Gatherv(h_act, n_act_loc, MPI_DOUBLE_PRECISION, h_act, 
     $                 n_act_v, disp_act_v, MPI_DOUBLE_PRECISION,
     $                 rootRank,MPI_COMM_WORLD,ierr)
      endif
      
      CALL MPI_Bcast(h_act, n_act, MPI_DOUBLE_PRECISION, rootRank,
     $                                          MPI_COMM_WORLD,ierr)

      if(myRank .eq. rootRank) then
      CALL MPI_Gatherv(MPI_IN_PLACE, n_act_loc, MPI_DOUBLE_PRECISION, 
     $                 m_act, n_act_v, disp_act_v, 
     $                 MPI_DOUBLE_PRECISION,rootRank,
     $                                          MPI_COMM_WORLD,ierr)
      else
      CALL MPI_Gatherv(m_act, n_act_loc, MPI_DOUBLE_PRECISION, m_act, 
     $                 n_act_v, disp_act_v, MPI_DOUBLE_PRECISION,
     $                 rootRank,MPI_COMM_WORLD,ierr)
      endif
      CALL MPI_Bcast(m_act, n_act, MPI_DOUBLE_PRECISION, rootRank,
     $                                          MPI_COMM_WORLD,ierr)


#endif
#ifdef NOMPI 
      n_act = n_act_loc         ! set total number of active particles for serial runs (NOMPI)
#endif

#ifdef DEBUG
      
      WRITE(STDERR,500) myRank,n_act
 500  FORMAT('PE',I2.2,': received a total of ',I8,' active particles')
#endif


      RETURN
      END

module viewermod

use opengl_gl
use opengl_glu
use opengl_glut

implicit none
 private
 save
 public :: initViewer,reset_to_init            ! initialize viewer
 public :: NormalKey,MouseClick, &             ! public to allow application
           MouseClickMotion,NormalKeyUp        ! to 'take over'
 public :: freeflightQ, leftbuttonQ, rightbuttonQ,slewQ,outputtext   
                                                     
integer, parameter :: MouseMovementScale=100
real(kind=gldouble), parameter :: curveScale=0.02
real(kind=gldouble), parameter :: freeFlightSpeed=0.0005
integer, parameter :: MouseMirror=1
real(kind=gldouble), parameter :: M_PI=3.14159265358979323846_gldouble
real(kind=gldouble),dimension(3), parameter :: zero=(/0.,0.,0./)
real, parameter :: minSpotDistance=.001
integer(kind=glcint), parameter :: RESET = 10, QUIT = 11
real(kind=gldouble) :: scaleFactor=1.
real(kind=gldouble), dimension(3) :: cam,spot,upvector=(/0.,0.,1./),up,ri,dummy
real, dimension(2) :: mousexyzero
integer :: npart, leftbutton=1,rightbutton=1,free_flight=0
real(kind=gldouble) :: viewangle=45.,ratio,angle
real(kind=gldouble):: nearplane=0.01,farplane=10000.
real(kind=gldouble) :: mx,my
real(kind=gldouble) :: fi=0.,theta=0.,r=1.
real(kind=gldouble),dimension(3) :: da=(/0.,0.03, 0.1/) 
logical :: slew=.TRUE.


 contains

! state query functions
integer function freeflightQ();freeflightQ=free_flight;end function
integer function leftbuttonQ();leftbuttonQ=leftbutton;end function leftbuttonQ
integer function rightbuttonQ();rightbuttonQ=rightbutton;end function rightbuttonQ
logical function slewQ();slewQ=slew;end function slewQ

subroutine rotate(moving,fixed,r,fi,theta)
  real(kind=gldouble), dimension(3), intent(inout) :: moving
  real(kind=gldouble), dimension(3), intent(in) :: fixed
  real(kind=gldouble),intent(in) :: r, fi, theta
 
 moving(1)=fixed(1)+r*sin(fi)*cos(theta)
 moving(2)=fixed(2)+r*cos(fi)*cos(theta)
 moving(3)=fixed(3)+r*sin(theta)
end subroutine rotate

subroutine translate(one,two,trans)
  real(kind=gldouble), dimension(3), intent(inout) :: one,two
  real(kind=gldouble), dimension(3), intent(in) :: trans
 
 one(1)=one(1)+trans(1);two(1)=two(1)+trans(1)
 one(2)=one(2)+trans(2);two(2)=two(2)+trans(2)
 one(3)=one(3)+trans(3);two(3)=two(3)+trans(3)

end subroutine translate

function distance2( o, t)
  real(kind=gldouble), dimension(3), intent(in) :: o,t
  real(kind=gldouble) :: distance2
 distance2=(o(1)-t(1))**2+(o(2)-t(2))**2+(o(3)-t(3))**2
 return 

end function distance2

subroutine pointCamera()

 call glMatrixMode(GL_MODELVIEW)
 call glLoadIdentity()
 call gluLookAt( cam(1), cam(2), cam(3), &
                 spot(1), spot(2), spot(3), &
		 upvector(1), upvector(2), upvector(3))

end subroutine pointCamera


subroutine ReshapeWindow( width, height)
  integer(kind=glint), intent(inout) :: width,height
 
 if(height.LT.1) height=1
 ratio=width/real(height)
 call glViewPort(0,0,width,height)
 call glMatrixMode(GL_PROJECTION)
 call glLoadIdentity()
 call gluPerspective(viewangle, ratio, nearplane, farplane);
 call pointCamera()
 
end subroutine ReshapeWindow


subroutine MouseClick(button, state, x, y)
  integer(kind=glcint),intent(in out) :: button,state,x,y 
   
 if(button.EQ.GLUT_LEFT_BUTTON) then
  if(state.EQ.GLUT_DOWN) leftbutton=0
  if(state.EQ.GLUT_UP) leftbutton=1
 mousexyzero(1)=x;mousexyzero(2)=y
 mx=0.;my=0.
 endif
 if(button.EQ.GLUT_MIDDLE_BUTTON) then
  if(state.EQ.GLUT_DOWN) rightbutton=0
  if(state.EQ.GLUT_UP) rightbutton=1
 mousexyzero(1)=x;mousexyzero(2)=y
 endif
  
end subroutine MouseClick

subroutine MouseClickMotion(x,y)
  integer(kind=glcint),intent(in out) :: x,y 
  real(kind=gldouble) :: rscl
  real(kind=gldouble),dimension(3) :: trans=(/0.,0.,0./)
 if((.NOT.(leftbutton.EQ.0)).AND.(.NOT.(rightbutton.EQ.0))) return

 if((.NOT.(leftbutton.EQ.0)).AND.(rightbutton.EQ.0)) then
  if(.NOT.slew) then
   r=r*2**((y-mousexyzero(2))/MouseMovementScale)
   if(r.LT.minSpotDistance) r=minSpotDistance
   if(r.gt.1000*scaleFactor) r=1000*scaleFactor
   call rotate(cam, spot,r,fi,theta)
  endif
  if(slew) then
   call rotate(trans,zero, &
         scaleFactor*((y-mousexyzero(2))/MouseMovementScale/2),fi,theta)
   call translate(cam,spot,trans)
  endif  
 endif

 if((leftbutton.EQ.0).AND.(.NOT.(rightbutton.EQ.0))) then
  if(free_flight.EQ.1) then
   mx=mx+(x-mousexyzero(1))/MouseMovementScale
   my=my+(y-mousexyzero(2))/MouseMovementScale
   if(abs(mx).LT.0.02) mx=0.
   if(abs(my).LT.0.02) my=0.  
  endif
  if(free_flight.EQ.0) then
   fi=fi+(x-mousexyzero(1))/MouseMovementScale
   theta=theta+(y-mousexyzero(2))/MouseMovementScale
   if(theta.GT.M_PI/2.) theta=M_PI/2.-0.001
   if(theta.LT.-M_PI/2.) theta=-M_PI/2.+0.001
   if(slew) then
    call rotate(spot, cam,r,fi+M_PI,-theta)
   else
    call rotate(cam, spot,r,fi,theta)
   endif
  endif
 endif
 
 if((leftbutton.EQ.0).AND.(rightbutton.EQ.0)) then
  viewangle=viewangle*(1+(y-mousexyzero(2))/MouseMovementScale)
  if(viewangle.LT.1) viewangle=1
  if(viewangle.GT.120) viewangle=120
  call glMatrixMode(GL_PROJECTION)
  call glLoadIdentity()
  call gluPerspective(viewangle, ratio, nearplane, farplane)
 endif
 mousexyzero(1)=x;mousexyzero(2)=y;
 call pointCamera
 call glutPostRedisplay
 
end subroutine MouseClickMotion

subroutine NormalKey( key, x, y)
  integer(kind=glcint),intent(in out) :: key
  integer(kind=glcint),intent(in out) :: x,y
 mx=0.;my=0.
 if(key.EQ.32) then 
  free_flight=1 
  slew=.TRUE.
 endif
 if(key.eq.113) call glutLeaveMainLoop()
 if(key.eq.99) then
  print*,'----- view parameters -----'
  write(*,'("spot: ",3f8.2)') spot  
  write(*,'("cam: ",3f8.2)') cam
  write(*,'("dir: ",3f8.2)') spot-cam  
 endif
end subroutine NormalKey

subroutine NormalKeyUp( key, x, y)
  integer(kind=glint),intent(in out) :: key
  integer(kind=glcint),intent(in out) :: x,y
 mx=0.;my=0.
 if(key.EQ.32) free_flight=0 
end subroutine NormalKeyUp

recursive subroutine frame(dummy)
  real(kind=gldouble),dimension(3) :: trans=(/0.,0.,0./)
integer(kind=glint), intent(in out) :: dummy
 if(free_flight.EQ.1) then
  call rotate(trans,zero,-freeFlightSpeed*scaleFactor,fi,theta)
  call translate(cam,spot,trans)
 if(leftbutton.EQ.0) then
  fi=fi+mx*curveScale
  theta=theta+my*curveScale
  if(theta.GT.M_PI/2.) theta=M_PI/2.-0.001
  if(theta.LT.-M_PI/2.) theta=-M_PI/2.+0.001
  call rotate(spot,cam,r,fi+M_PI,-theta)
 endif 
  call pointCamera
  call glutPostRedisplay
 endif
 call glutTimerFunc(50, frame, 0)
end subroutine frame

subroutine MouseMoves( x, y)
  integer(glint) :: x,y
 
 if(free_flight.EQ.1) then
  mx=mx+(x-mousexyzero(1))/MouseMovementScale
  my=my+(y-mousexyzero(2))/MouseMovementScale
  if(abs(mx).LT.0.02) mx=0.
  if(abs(my).LT.0.02) my=0.
 endif
end subroutine MouseMoves

subroutine menu_handler(value)
  integer(kind=glcint), intent(in out) :: value
 select case(value)
 case(RESET)
   call reset_to_init
 case(QUIT)
   call glutLeaveMainLoop()
 end select
 return
end subroutine menu_handler

subroutine reset_to_init(scale,centre)
  real,optional :: scale,centre(3)

 if(present(scale)) scaleFactor=scale
 spot(1)=0.;spot(2)=0. ;spot(3)=0.
 if(present(centre)) spot=centre

 slew=.FALSE.
 r=scaleFactor;fi=0.57;theta=0.3
 call rotate( cam,spot,r,fi,theta);
 call pointCamera
 call glutPostRedisplay 
end subroutine reset_to_init

function initViewer(scale,centre) result(menuid)
  real,optional :: scale,centre(3)
  integer(kind=glcint) :: menuid
 
 

 
 menuid = glutCreateMenu(menu_handler)
 call glutAddMenuEntry("reset to initial view",RESET)
 call glutAddMenuEntry("quit",QUIT)

 call glutReshapeFunc( ReshapeWindow)
 call glutMousefunc( MouseClick)
 call glutMotionFunc( MouseClickMotion)
 call glutIgnoreKeyRepeat(1)
 call glutKeyboardFunc( NormalKey )
 call glutKeyboardUpFunc( NormalKeyUp)
 call glutTimerFunc(50, frame, 0)

 call reset_to_init(scale,centre)
end function initViewer

subroutine outputtext(x,y,s)
  real(kind=gldouble) :: x,y
  character :: s*(*)
  character :: c
  integer :: i,lenc
  
  call glrasterpos2d(x,y)
  lenc = len(s)
  do i=1,lenc
    c = s(i:i)
    call glutbitmapcharacter(GLUT_BITMAP_HELVETICA_18, &
          ichar(c))
  end do
end subroutine outputtext


end module viewermod

module snap_viewer
 
  use opengl_gl
  use opengl_glut
  use opengl_glu
 save
 private
 public :: initnbody,display,attachmenu,createsubmenus, &
  NormalKey2,starscale,starcentre,starreset,visible
 public :: da
 
  integer, parameter :: NMAX=5000000
  integer, parameter :: GAS=1,STAR=2,HALO=3,AXES=4,BOX=5
  real(kind=gldouble) :: boxsize
  real(kind=glfloat),dimension(3) :: da=(/0.,0., 1./) 
  real(kind=glfloat),dimension(3) :: no=(/1.,0., 0./) 
!  real(kind=glfloat),dimension(3) :: da=(/.15,.075, .026/) 
!  real(kind=glfloat),dimension(3) :: no=(/1.,0., .0/) 
 
  logical :: show_gas=.FALSE.,show_stars=.TRUE.,show_halo=.FALSE.
  logical :: show_axes=.FALSE.,show_box=.TRUE.,show_data=.TRUE.
  integer(glint) :: update_flag=0 
    
  integer(glint) ::framerate=5000;
  integer(glint), parameter:: FASTUPDATE=50,SLOWUPDATE=5000
  
  real(kind=glfloat),save :: pointsize_gas=3.,pointsize_stars=1.5,pointsize_halo=1.
  
  real(kind=gldouble) :: top(3),bot(3)
    
 contains

subroutine visible(state)
integer(glcint),intent(inout) :: state
  if (state == GLUT_VISIBLE) then
!    if(update_flag.EQ.0) call starreset(0_glint)
   else
   update_flag=0 
  endif
end subroutine visible


subroutine starslist
#include "general.inc"
  real(kind=glfloat) :: xt,yt,zt,temp,red,green,blue,alpha_c
  integer :: i,step

  step=max(N/NMAX,1)
  if(.not.show_stars) return

  call glNewList(2,GL_COMPILE)
  call glPointSize( pointsize_stars)
  call glColor4f(.8_glfloat, .8_glfloat, .6_glfloat,.6_glfloat)
  call glBegin(GL_POINTS)
  do i=1,N,step

    xt=x(1,i)
    yt=x(2,i)
    zt=x(3,i)

    call glVertex3f(xt,yt,zt)	
  end do
  call glEnd()
  call glEndList()
end subroutine starslist

subroutine boxlist
 
 call glNewList(BOX,GL_COMPILE)
 call glBegin(GL_LINES)
 call glColor4f(.4_glfloat, .5_glfloat, .9_glfloat,1._glfloat)

 call glvertex3d(top(1),top(2),top(3))
 call glvertex3d(top(1),top(2),bot(3))

 call glvertex3d(top(1),top(2),top(3))
 call glvertex3d(top(1),bot(2),top(3))

 call glvertex3d(top(1),top(2),top(3))
 call glvertex3d(bot(1),top(2),top(3))

 call glvertex3d(bot(1),top(2),top(3))
 call glvertex3d(bot(1),top(2),bot(3))

 call glvertex3d(bot(1),top(2),top(3))
 call glvertex3d(bot(1),bot(2),top(3))

 call glvertex3d(top(1),bot(2),top(3))
 call glvertex3d(top(1),bot(2),bot(3))

 call glvertex3d(top(1),bot(2),top(3))
 call glvertex3d(bot(1),bot(2),top(3))

 call glvertex3d(top(1),top(2),bot(3))
 call glvertex3d(top(1),bot(2),bot(3))

 call glvertex3d(top(1),top(2),bot(3))
 call glvertex3d(bot(1),top(2),bot(3))

 call glvertex3d(bot(1),bot(2),bot(3))
 call glvertex3d(top(1),bot(2),bot(3))

 call glvertex3d(bot(1),bot(2),bot(3))
 call glvertex3d(bot(1),top(2),bot(3))

 call glvertex3d(bot(1),bot(2),bot(3))
 call glvertex3d(bot(1),bot(2),top(3))
 
 call glEnd()
 call glEndList()

end subroutine


function starscale() result(scale_factor)
#include "general.inc"
	real(kind=gldouble) :: maxcor,maxcorg,maxcors,scale_factor
! schaal:
	maxcor=maxval(abs(x(1:3,1:N)))	
	if(maxcor.le.0) maxcor=1.
	scale_factor=2._gldouble*maxcor
	initialbox=2*maxcor
        top=initialbox/2
        bot=-initialbox/2
	return
end function starscale

function starcentre() result(centre)
  real :: centre(3)
        centre=top/2+bot/2
end function starcentre

recursive subroutine starreset(dummy)
 integer(glint) :: dummy
 call prerender()
 call glutPostRedisplay
 if(update_flag.NE.0) call glutTimerFunc( framerate, starreset, 1_glint)
end subroutine starreset

subroutine show_menu(optie)
  integer(kind=glint), intent(inout) :: optie
  
 select case (optie)
 case(1)
  show_stars=.NOT.show_stars
 case(2)
  show_gas=.NOT.show_gas
 case(3)
  show_halo=.NOT.show_halo
 case(4)
  call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,no)
 case(5) 
  call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,da)
 case(6)
  show_data=.NOT.show_data
 case(7)
  show_axes=.NOT.show_axes 
 case(8)
 if(pointsize_gas.LT.10) then
  pointsize_gas=pointsize_gas*1.5
  pointsize_stars=pointsize_stars*1.5
  pointsize_halo=pointsize_halo*1.5
 endif
 case(9)
 if(pointsize_gas.GT.1) then
  pointsize_gas=pointsize_gas/1.5
  pointsize_stars=pointsize_stars/1.5
  pointsize_halo=pointsize_halo/1.5
 endif
 case default
 end select

 call glutPostRedisplay
 
end subroutine show_menu

subroutine prop_menu(optie)
integer(glcint), intent(inout)::optie
integer(glint) :: dummy,flag

select case (optie)
 case(1)
 show_temp=0
 case(2)
 show_temp=1
 case(3)
 show_temp=2
 case(4)
 case default

end select

 flag=update_flag
 update_flag=0
 call starreset(flag)
 update_flag=flag

end subroutine prop_menu

subroutine update_menu(optie)
 use viewermod
integer(glcint),intent(inout) ::optie
integer(glint) :: dummy,flag
real :: rsize

select case(optie)

 case(0)
  update_flag=0
 case(1)
  flag=update_flag
  update_flag=0
  if(flag.EQ.0) call starreset(0_glint)
  update_flag=flag
 case(2)
  framerate=SLOWUPDATE
  if(update_flag.EQ.0) then 
   update_flag=7  
   call starreset(0_glint)
  endif
 case(3)
  framerate=FASTUPDATE
  if(update_flag.EQ.0) then 
   update_flag=7  
   call starreset(0_glint)
  endif
 case(4)
 case(5)
 case(6)
  rsize=starscale()
  call reset_to_init(rsize,starcentre())
  da(3)=1./rsize**2*16.
  da(2)=da(3)*rsize/2.

! i added this in the hopes that it would update the new box for a new psys
!  boxsize=starscale()
!  da(3)=1./boxsize**2*16.
!  da(2)=da(3)*boxsize/2.

  flag=update_flag
  update_flag=0
  call starreset(0_glint)
  update_flag=flag
 case default 

end select

end subroutine update_menu

subroutine createsubmenus(i,j,k)
  integer(glcint),intent(inout) :: i,j,k
 
 i=glutCreateMenu(update_menu)
 call glutaddmenuentry('update scale', 6)
 call glutaddmenuentry('no updates', 0)
 call glutaddmenuentry('refresh view', 1)
 call glutaddmenuentry('slow update', 2)
 call glutaddmenuentry('fast update', 3)

 j=glutCreateMenu(show_menu)
 call glutaddmenuentry('toggle stars', 1)
 call glutaddmenuentry('toggle gas', 2)
 call glutaddmenuentry('toggle halo', 3)
 call glutaddmenuentry('normal points', 4)
 call glutaddmenuentry('EXT points', 5)
 call glutaddmenuentry('toggle data', 6)
 call glutaddmenuentry('toggle axes', 7)
 call glutaddmenuentry('increase pointsize', 8)
 call glutaddmenuentry('decrease pointsize', 9)

 k=glutCreateMenu(prop_menu)
 call glutaddmenuentry('plain', 1)

end subroutine createsubmenus

subroutine attachmenu(i,j,k)
 integer(glcint),intent(in) :: i,j,k
 call glutaddsubmenu('update options', i)
 call glutaddsubmenu('view options', j)
 call glutaddsubmenu('show options',k)

end subroutine attachmenu

subroutine prerender()
 integer(glint) :: flag
! call gaslist
 call starslist
! call rlist
 call boxlist
 call axeslist
end subroutine prerender

subroutine NormalKey2( key, x, y)
 use viewermod
  integer(kind=glcint),intent(in out) :: key
  integer(kind=glcint),intent(in out) :: x,y
 if(key.EQ.110) then 
! 'N'
 endif
  if(key.EQ.112) then
! 'P'
 endif
 call Normalkey( key,x,y)
end subroutine NormalKey2

subroutine display  
 call glClear(ior(GL_COLOR_BUFFER_BIT,GL_DEPTH_BUFFER_BIT))
  call glBlendFunc(GL_SRC_ALPHA,GL_ONE)
  call glDepthFunc(GL_ALWAYS)
  if( show_stars) call renderstars
  if( show_halo) call renderhalo
  if( show_gas) call rendergas


  call glDepthFunc(GL_LESS)
  call glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
  call glCallList(BOX)

  call glDepthFunc(GL_GEQUAL)
  call glBlendFunc(GL_ONE_MINUS_DST_ALPHA,GL_ONE)
  call glCallList(BOX)

  call glDepthFunc(GL_LESS)
  call glBlendFunc(GL_ONE,GL_ZERO)
  call drawtext

  
!  call glDepthFunc(GL_LESS)
!  call glDepthMask(.TRUE.)
!  call glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA)
!  if( show_axes) call glCallList(AXES)
!  call glCallList(BOX)
!  if( show_axes) call glCallList(AXES)

!  call glDepthMask(.FALSE.)
!  call glDepthFunc(GL_ALWAYS)
!  call glBlendFunc(GL_SRC_ALPHA,GL_ONE)
!  if( show_stars) call renderstars
!  if( show_halo) call renderhalo
!  if( show_gas) call rendergas

!  call glDepthMask(.TRUE.)
!  call glDepthFunc(GL_LESS)
!  call glBlendFunc(GL_ONE,GL_ZERO)
!  call drawtext
 call glutSwapBuffers();
end subroutine display

subroutine rendergas
 call glCallList(GAS)
end subroutine rendergas

subroutine renderstars
 call glCallList(STAR)
end subroutine renderstars

subroutine renderhalo
  call glCallList(HALO)
end subroutine renderhalo

subroutine axeslist

 call glNewList(AXES,GL_COMPILE)
 call glPushMatrix
 call glScaled(boxsize/3,boxsize/3,boxsize/3)
 call glColor4f(.2_glfloat, 1._glfloat, .2_glfloat,.8_glfloat)
 call glBegin(GL_LINES)
 call glVertex3f(-2.0_glfloat,0.0_glfloat,0.0_glfloat)
 call glVertex3f(2.0_glfloat,0.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,-2.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,2.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,0.0_glfloat,-2.0_glfloat)
 call glVertex3f(0.0_glfloat,0.0_glfloat,2.0_glfloat)

! Draw crude x, y and z to label the axes

 call glVertex3f(2.1_glfloat,-0.1_glfloat,0.1_glfloat) ! X
 call glVertex3f(2.1_glfloat,0.1_glfloat,-0.1_glfloat)
 call glVertex3f(2.1_glfloat,-0.1_glfloat,-0.1_glfloat)
 call glVertex3f(2.1_glfloat,0.1_glfloat,0.1_glfloat)
 call glVertex3f(0.1_glfloat,2.1_glfloat,0.1_glfloat) ! Y
 call glVertex3f(0.0_glfloat,2.1_glfloat,0.0_glfloat)
 call glVertex3f(-0.1_glfloat,2.1_glfloat,0.1_glfloat)
 call glVertex3f(0.1_glfloat,2.1_glfloat,-0.1_glfloat)
 call glVertex3f(-0.1_glfloat,0.1_glfloat,2.1_glfloat) ! Z
 call glVertex3f(0.1_glfloat,0.1_glfloat,2.1_glfloat)
 call glVertex3f(0.1_glfloat,0.1_glfloat,2.1_glfloat)
 call glVertex3f(-0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glVertex3f(-0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glVertex3f(0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glEnd

 call glPopMatrix

 call glEndList

end subroutine axeslist

subroutine drawtext
 use viewermod
#include "general.inc"
  character*3 rs3
  character*8 rs
  character*10 rs10
  integer(kind=glint) :: viewport(4)
  real(kind=gldouble) :: xp1,xp2,yp1,yp2
  
  if(.not.show_data) return
  call glGetIntegerv(GL_VIEWPORT,viewport)
  xp1=viewport(1)
  yp1=viewport(2)
  xp2=viewport(3)
  yp2=viewport(4) 
  call glmatrixmode(GL_PROJECTION)  
  call glPushMatrix
  call glLoadIdentity
  call glortho(xp1,xp2,yp1,yp2,-1._gldouble,1._gldouble) 
  call glmatrixmode(GL_MODELVIEW)
  call glPushMatrix
  call glLoadIdentity
  call glColor4f(0.0_glfloat,.5_glfloat,1.0_glfloat,0.5_glfloat)
  if(yp2-yp1.gt.120) then
   if(xp2-xp1.gt.320) then
    write(rs,'(f8.2)') time_cur
    call outputtext(xp1+3._gldouble,yp1+3._gldouble,'time:'//rs)
    write(rs,'(f8.2)') top(1)-bot(1)
    call outputtext(xp2-120._gldouble,yp1+3._gldouble,'box:'//rs)
   endif

   if(xp2-xp1.gt.200) then
    write(rs,'(i8.8)') 0
    call outputtext(xp1+3._gldouble,yp2-20._gldouble,'halo:')
    if(.not.show_halo) call glColor4f(0.4_glfloat,0.4_glfloat,0.4_glfloat,0.5_glfloat)
    call outputtext(xp1+70._gldouble,yp2-20._gldouble,rs)
    call glColor4f(0._glfloat,.6_glfloat,1.0_glfloat,0.8_glfloat)

    write(rs,'(i8.8)') 0
    call outputtext(xp1+3._gldouble,yp2-40._gldouble,'gas:')
    if(.not.show_gas) call glColor4f(0.4_glfloat,0.4_glfloat,0.4_glfloat,0.5_glfloat)
    call outputtext(xp1+70._gldouble,yp2-40._gldouble,rs)
    call glColor4f(0._glfloat,.6_glfloat,1.0_glfloat,0.8_glfloat)

    write(rs,'(i8.8)') N
    call outputtext(xp1+3._gldouble,yp2-60._gldouble,'stars:')
    if(.not.show_stars) call glColor4f(0.4_glfloat,.4_glfloat,.4_glfloat,0.5_glfloat)
    call outputtext(xp1+70._gldouble,yp2-60._gldouble,rs)
  endif
  endif
  call glPopMatrix
  call glmatrixmode(GL_PROJECTION)
  call glPopMatrix
  call glmatrixmode(GL_MODELVIEW)
end subroutine drawtext

function initnbody()
#include "general.inc"
  real :: initnbody
  
 boxsize=starscale()
 initnbody=boxsize
 da(3)=1./initnbody**2*16.
 da(2)=da(3)*initnbody/2.

 call prerender()
 
end function initnbody

end module snap_viewer


subroutine pt_setup
	
end subroutine pt_setup

subroutine viewbodies
 use viewermod
 use snap_viewer
 use opengl_gl
 use opengl_glut
 use opengl_glu
 implicit none
  real :: rsize
  integer(glcint) :: i,j,k,flag
  integer(glcint) :: win,menu
 
 if(glutGet(GLUT_ELAPSED_TIME).NE.0) then
  print*,'already viewer present'
!  return
 endif
  
 call glutInit
 call glutInitWindowPosition(100,100)
 call glutInitWindowSize(700,400)
 call glutInitDisplayMode(ior(GLUT_DEPTH,ior(GLUT_RGBA,GLUT_DOUBLE)))
 
 win=glutCreateWindow("3D Viewer")
 call createsubmenus(i,j,k)
 
 rsize=initnbody()
 
 menu=initViewer(rsize,starcentre()) 
! NB
 call glutKeyboardFunc( NormalKey2 )
! NB (in initnbody?)
 call glutAttachMenu(GLUT_RIGHT_BUTTON)
 call attachmenu(i,j,k)
 call glutDisplayFunc(display)

 call glClearColor(0.02_glclampf, 0.02_glclampf, 0.02_glclampf, 1.0_glclampf)

 call glEnable(GL_DEPTH_TEST)
 call glEnable(GL_BLEND)
 call glBlendFunc(GL_SRC_ALPHA,GL_ONE)
 call glEnable(GL_POINT_SMOOTH)
 call glEnable(GL_LINE_SMOOTH)
 call glHint(GL_LINE_SMOOTH_HINT, GL_NICEST)
 call glHint(GL_POINT_SMOOTH_HINT, GL_NICEST)
 call glLineWidth(1.55_glfloat)
 call glPointParameterfvARB(GL_POINT_DISTANCE_ATTENUATION_ARB,da)
 call glPointParameterfARB(GL_POINT_SIZE_MIN_ARB, 1._glfloat) 
 call glPointParameterfARB(GL_POINT_FADE_THRESHOLD_SIZE_ARB, 0._glfloat) 


 call glutTimerFunc(100, starreset,0_glint)
 call glutVisibilityFunc(visible)

 call glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE,GLUT_ACTION_GLUTMAINLOOP_RETURNS)
 call glutMainLoop()

end subroutine viewbodies

      SUBROUTINE get_min_t
      IMPLICIT NONE
#include "general.inc"

      INTEGER          i
      DOUBLE PRECISION min_t_loc,tnext
#ifndef NOMPI
#include <mpif.h>
C---  some short cuts
      INTEGER   ierr
C      INTEGER   MPI_INT,MPI_DOUBLE_PRECISION
C      PARAMETER(MPI_INT=MPI_INTEGER,MPI_DOUBLE_PRECISION=MPI_DOUBLE_PRECISION)
#endif

C---  check for active particles
      IF (n_loc.EQ.0) RETURN    ! this would be bad

C---  get local minimum of next time step
      min_t_loc = t_loc(1)+dt_loc(1)
      DO i=2,n_loc
         tnext = t_loc(i) + dt_loc(i)
         IF (tnext.LT. min_t_loc) min_t_loc = tnext
      ENDDO

#ifndef NOMPI
C---  get global mininum of min_t_loc
      CALL MPI_Allreduce(min_t_loc, min_t, 1, MPI_DOUBLE_PRECISION,
     $                                MPI_MIN, MPI_COMM_WORLD,ierr)
#endif
#ifdef NOMPI
      min_t = min_t_loc
#endif

#ifdef DEBUG
      IF (myRank.EQ.0) THEN
         WRITE(0,500) min_t
      ENDIF
 500  FORMAT('root: minum time step min_t =',1P,E15.6)
#endif

      RETURN
      END

      SUBROUTINE initgrape
C===  init the local GRAPE
      IMPLICIT NONE
#include "general.inc"

C---  local vars
      INTEGER new_xunit,new_tunit,aflag,jflag,pflag

C---  functions
      INTEGER g6_npipes

C---  set x- and tunit
      new_xunit = 48
      new_tunit = 48
      aflag     = 1
      jflag     = 1
      pflag     = 1
      clusterid = 0

C---  open GRAPE and set some parameters
      CALL  g6_open(clusterid)
C           -------
      npipe = g6_npipes()

      CALL g6_set_tunit(new_tunit)
      CALL g6_set_xunit(new_xunit)


#ifdef DEBUG
      WRITE(STDERR,600) myRank
 600  FORMAT('PE',I2.2,': local GRAPE is initialized')
      CALL flush(STDERR)
#endif

      RETURN
      END

      SUBROUTINE update_grape(imode)
C=========================================================================
C===  update particles on GRAPE
C===  imode = 0: active particles only
C===          1: all local particles
C=========================================================================
      IMPLICIT NONE
#include "general.inc"

C---  local vars
      DOUBLE PRECISION a2by18(NDIM),a1by6(NDIM),aby2(NDIM)
      INTEGER i,j,k,ii,jj,imode

C---  get first index of local active particle
      ii = disp_act_v(myRank+1)

      IF (imode.NE.1) THEN

         DO j=1,n_act_loc

            i  = ind_act_loc(j) ! local index of j-th active particle
            jj = ii+j           ! index of same particle in global body_act
            
            DO k=1,NDIM

               a2by18(k) = 0.d0 
               a1by6(k)  = adot_act(k,j) * over6 
               aby2(k)   = a_act(k,j)    * over2

            ENDDO

            if (i .gt. nbh) then 

               CALL g6_set_j_particle(clusterid, i-1-nbh, ind_act(jj),
     $              t_act(j),
     $              dt_act(j),m_act(jj),a2by18,a1by6,aby2,
     $              v_act(1,j), x_act(1,j))
            end if
         
         ENDDO

      ELSE

C---  sending all local particles
         DO j=nbh+1,n_loc
            
            DO k=1,NDIM
               a2by18(k) = 0.d0 
               a1by6(k)  = adot_loc(k,j)*over6 
               aby2(k)   = a_loc(k,j)*over2
            ENDDO
            
            CALL g6_set_j_particle(clusterid, j-1-nbh, ind_loc(j), 
     $           t_loc(j),
     $                             dt_loc(j), m_loc(j), a2by18, a1by6,
     $                             aby2, v_loc(1,j), x_loc(1,j))
C                -----------------
         ENDDO

      ENDIF


      RETURN
      END

      SUBROUTINE update_loc_p
      IMPLICIT NONE
#include "general.inc"


C---  local vars
      INTEGER i,j,k

C---  update local particles
      DO i=1,n_act_loc

         j = ind_act_loc(i)           ! get the local index of i-th active particle
         DO k=1,NDIM
            x_loc(k,j)    = x_act(k,i)
            v_loc(k,j)    = v_act(k,i)
            a_loc(k,j)    = a_act(k,i)
            adot_loc(k,j) = adot_act(k,i)
         ENDDO
         pot_loc(j)       = pot_act(i)
         t_loc(j)         = t_act(i)
         dt_loc(j)        = dt_act(i)


      ENDDO


      RETURN
      END

      SUBROUTINE readpars
C=========================================================================
C===
C===  task:  read parameter file
C===  -----  
C===
C===  parameter:   eps                  softening parameter (can be 0)
C===  ----------   t_end                end time of simulation
C===               dt_disk              output interval for snapshots
C===               dt_contr             output interval for energy etc.
C===               dt_bh                output interval for BH data
C===               dt_timing            output interval for timing info
C===               dt_max               maximum time step
C===               eta_s                intital time step parameter
C===               eta                  time step parameter
C===               irestart             =1 snapshot file is a restart file
C===               icmcorr              =1 correct snapshot for CofM if it 
C===                                    is the first snapshot (diskstep=0)
C===               inp_fname            name of initial snapshot file
C===
C=========================================================================
C===                                                   17/08/2006 by SH 
C=========================================================================
      IMPLICIT NONE
#include "general.inc"

      OPEN(10,FILE='phiGRAPE.inp')
      
      READ(10,*) eps 
      READ(10,*) t_end
      READ(10,*) dt_disk
      READ(10,*) dt_contr
      READ(10,*) dt_bh
      READ(10,*) dt_timing
      READ(10,*) dt_restart
      READ(10,*) dt_max
      READ(10,*) eta_s
      READ(10,*) eta
      READ(10,*) irestart,icmcorr
      READ(10,*) nbh
      READ(10,*) inp_fname

      CLOSE(10)

#ifdef DEBUG
         WRITE(STDERR,*) eps, t_end, dt_disk, dt_contr, dt_bh, eta_s,
     $                   eta, nbh, inp_fname
#endif


      RETURN
      END

      SUBROUTINE gravity(tnow,ifirst)
C===  calc the grav for the active particles in first step
      IMPLICIT NONE
#include "general.inc"
#include "stopcond.inc"

      INTEGER is_stopping_condition_enabled
      INTEGER is_collision_detection_enabled
      INTEGER next_index_for_stopping_condition
      INTEGER set_stopping_condition_info
      INTEGER set_stopping_condition_particle_index
      INTEGER stopping_index
      INTEGER reset_stopping_conditions
      INTEGER error

C---  input vars
      INTEGER          ifirst
      DOUBLE PRECISION tnow

C---  GRAPE vars
      INTEGER    NGP
      PARAMETER (NGP=16384)

      INTEGER g6err, g6calc_lasthalf, g6calc_lasthalf2

C---  local vars
      INTEGER ni,nn,i,ii,iii,ig,k,index_i(NGP),nn_i(NGP),id1,id2,j,nj,
     $        ip1,ip2
      DOUBLE PRECISION x_i(NDIM,NGP),v_i(NDIM,NGP),a_i(NDIM,NGP),
     $                 jerk_i(NDIM,NGP),p_i(NGP),h2_i(NGP)
      DOUBLE PRECISION hsum2,r2,r(NDIM),dttmp,dt2half,dt3over6
      DOUBLE PRECISION xp, yp, zp, vxp, vyp, vzp, dtp, dtp2, dtp3
      DOUBLE PRECISION ax, ay, az, jx, jy, jz, potj
      DOUBLE PRECISION xi, yi, zi, vxi, vyi, vzi
      DOUBLE PRECISION dx, dy, dz, dvx, dvy, dvz
      DOUBLE PRECISION rr2, rv, rinv1, rinv2, rinv3, alpha
      DOUBLE PRECISION dv2

C---  set some initial guess for first call of GRAPES
      IF (ifirst.EQ.1) THEN
         DO i=1,n_act

            ig = ind_act(i)

            pot_act_tmp_loc(ig)       = -1.d0
            DO k=1,NDIM
               a_act_tmp_loc(k,ig)    = 1.d0
               adot_act_tmp_loc(k,ig) = 10.d0
            ENDDO
         ENDDO
      ENDIF

C---  set actual time on GRAPE
      CALL g6_set_ti(clusterid, tnow)

C---  n_act is all active particles and on all nodes the same
      ni = n_act

      error = is_stopping_condition_enabled(COLLISION_DETECTION,
     $        is_collision_detection_enabled)

C---  define the local phi, a, adot for these active particles
      DO i=0,ni-1,npipe
         nn = npipe                            ! block size 48 or smaller
         IF ((ni - i).LT.npipe) nn = ni - i
         DO ii=1,nn

            iii = i+ii
        
            ig  = ind_act(iii)
            index_i(ii) = ig
            h2_i(ii)    = eps2

            DO k=1,NDIM

               x_i(k,ii)    = body_pred(k,iii)
               v_i(k,ii)    = body_pred(k+3,iii)
               a_i(k,ii)    = a_act_tmp_loc(k,ig) ! some initial guess for a and jerk
               jerk_i(k,ii) = adot_act_tmp_loc(k,ig) ! using partial force from previous
                                                     ! call here
            ENDDO
            p_i(ii)         = pot_act_tmp_loc(ig)
         ENDDO

         IF (ifirst.EQ.1) THEN
C---  get forces etc. based on bad initial guess
           CALL g6calc_firsthalf(clusterid, n_loc-nbh, nn,
     $           index_i,x_i,v_i,
     $           a_i, jerk_i, p_i, eps2, h2_i)
           g6err = g6calc_lasthalf(clusterid, n_loc-nbh,nn,
     $          index_i,x_i,v_i,
     $          eps2, h2_i, a_i, jerk_i, p_i)


           DO ii=1,nn       ! test for bad jerk and reset
              IF (jerk_i(1,ii).EQ.0.d0) jerk_i(1,ii) = 1.d-5
              IF (jerk_i(2,ii).EQ.0.d0) jerk_i(2,ii) = 1.d-5
              IF (jerk_i(3,ii).EQ.0.d0) jerk_i(3,ii) = 1.d-5
           ENDDO

        ENDIF


C---  now get forces based on a (hopefully) good guess from a previous force calculation
        CALL g6calc_firsthalf(clusterid, n_loc-nbh, nn,
     $       index_i, x_i, v_i,
     $       a_i, jerk_i, p_i, eps2, h2_i)
        g6err = g6calc_lasthalf2(clusterid,
     $       n_loc-nbh, nn, index_i, x_i, v_i,
     $       eps2, h2_i, a_i, jerk_i, p_i,
     $       nn_i)


        IF (is_collision_detection_enabled.GT.0) THEN 
            DO ii=1,nn

                iii   = ii+i
                ip1   = index_i(ii)
                ip2   = nn_i(ii)
                id1   = myid(ip1)
                id2   = myid(ip2)
                ip2   = ip2 - ind_loc(1) + 1
                hsum2 = (h_act(iii)+h_loc(ip2))**2
                
C---  get the predicted position of secondary particle which may
C---  or may not be an active particle
                dttmp    = tnow - t_loc(ip2)
                dt2half  = 0.5d0 * dttmp * dttmp
                dt3over6 = dttmp * dt2half / 3.d0
                DO k=1,NDIM
                    r(k) = x_loc(k,ip2) + v_loc(k,ip2)*dttmp
     $                  + a_loc(k,ip2)*dt2half
     $                  + adot_loc(k,ip2)*dt3over6
     $                  - x_i(k,ii)
                ENDDO
                
C---  now compute sqaure of radius
                r2    = (r(1)**2 + r(2)**2 + r(3)**2)

C---  test for collision + bound? (fip)
                IF (hsum2.GE.r2) THEN
                    dv2=0
         
                    icollision  = 1 ! collision detected

C ELLO-- implement this according top stopcond lib C
                    IF (m_act(iii).GE.m_loc(ip2)) THEN
                        idprimary   = id1
                        idsecondary = id2
                    ELSE
                        idprimary   = id2
                        idsecondary = id1
                    ENDIF
            
                    call amuse_handle_collisions(id1, id2)
                    
C--                    GOTO 110    
C-- there was a GOTO 110 to prevent double detection of same collision, 
C-- but that is handled by the HL code now!

                ENDIF
            ENDDO
        ENDIF
  110   CONTINUE                ! break after detection of a collision
C---  temporary save forces etc. (will be summed over all PE's later)
        DO ii=1,nn

           iii = ii + i
           body_act_tmp(ipnew,iii)         = p_i(ii)
           DO k=1,NDIM
              body_act_tmp(iaxnew-1+k,iii) = a_i(k,ii)
              body_act_tmp(ijxnew-1+k,iii) = jerk_i(k,ii)
           ENDDO

        ENDDO

      ENDDO            ! finished getting forces etc for all active particles

C---  Store the value of the local partial force etc...
C---  this is needed as an initial guess for the next force calculation
C---  the *_tmp_loc arrays have forces etc excerted only by local particles
C---  and can be accessed by the global particle index
      DO i=1,n_act
         ig = ind_act(i)

         pot_act_tmp_loc(ig)       = body_act_tmp(ipnew,i)
         DO k=1,NDIM
            a_act_tmp_loc(k,ig)    = body_act_tmp(iaxnew-1+k,i)
            adot_act_tmp_loc(k,ig) = body_act_tmp(ijxnew-1+k,i)
         ENDDO

      ENDDO


      do i=1,n_act
         ig = ind_act(i)

         xi  = body_pred(1, i)
         yi  = body_pred(2, i)
         zi  = body_pred(3, i)
         vxi = body_pred(4, i)
         vyi = body_pred(5, i)
         vzi = body_pred(6, i)

         if (ig .le. nbh) then
            nj = n_loc
            body_act_tmp(1, i) = 0
            body_act_tmp(2, i) = 0
            body_act_tmp(3, i) = 0
            body_act_tmp(4, i) = 0
            body_act_tmp(5, i) = 0
            body_act_tmp(6, i) = 0
            body_act_tmp(7, i) = 0
         else
            nj = nbh
         end if

         do j = 1,nj
            dtp = min_t - t_loc(j)
            dtp2 = dtp*dtp/2.0
            dtp3 = dtp2*dtp/3.0

            xp = x_loc(1, j) + v_loc(1, j)*dtp +
     $           a_loc(1,j)*dtp2 + adot_loc(1,j)*dtp3
            yp = x_loc(2, j) + v_loc(2, j)*dtp +
     $           a_loc(2,j)*dtp2 + adot_loc(2,j)*dtp3
            zp = x_loc(3, j) + v_loc(3, j)*dtp +
     $           a_loc(3,j)*dtp2 + adot_loc(3,j)*dtp3

            vxp = v_loc(1, j) + a_loc(1, j)*dtp + adot_loc(1,j)*dtp2
            vyp = v_loc(2, j) + a_loc(2, j)*dtp + adot_loc(2,j)*dtp2
            vzp = v_loc(3, j) + a_loc(3, j)*dtp + adot_loc(3,j)*dtp2

            dx = xp - xi
            dy = yp - yi
            dz = zp - zi
            rr2 = dx*dx + dy*dy + dz*dz
            dvx = vxp - vxi
            dvy = vyp - vyi
            dvz = vzp - vzi

            if (ig .ne. j) then
               rinv1 = 1.0/sqrt(rr2 + bh_eps)
            else
               rinv1 = 0
            end if
            rv    = dx*dvx + dy*dvy + dz*dvz
            rinv2 = rinv1*rinv1
            alpha = rv * rinv2;
            rinv1 = rinv1 * m_loc(j)
            rinv3 = rinv1*rinv2

            ax   = rinv3*dx
            ay   = rinv3*dy
            az   = rinv3*dz
            jx   = rinv3*dvx - 3.0*alpha*ax
            jy   = rinv3*dvy - 3.0*alpha*ay
            jz   = rinv3*dvz - 3.0*alpha*az
            potj = - rinv1

            body_act_tmp(1, i) = body_act_tmp(1,i) + ax
            body_act_tmp(2, i) = body_act_tmp(2,i) + ay
            body_act_tmp(3, i) = body_act_tmp(3,i) + az
            body_act_tmp(4, i) = body_act_tmp(4,i) + jx
            body_act_tmp(5, i) = body_act_tmp(5,i) + jy
            body_act_tmp(6, i) = body_act_tmp(6,i) + jz
            body_act_tmp(7, i) = body_act_tmp(7,i) + potj
         end do

      end do

      RETURN
      END

      subroutine amuse_handle_collisions(id1, id2)
        implicit none
#include "stopcond.inc"
        integer, intent(in) :: id1, id2
        integer :: next_index_for_stopping_condition
        integer :: set_stopping_condition_info
        integer :: set_stopping_condition_particle_index
        integer :: sc_idx, err
        
C       Make sure each collision is reported only once:
        if (id1.GT.id2) return
        
        sc_idx = next_index_for_stopping_condition()
        err = set_stopping_condition_info(sc_idx, COLLISION_DETECTION)
        write(*,*) "Set stopping condition", sc_idx
        if (err.LT.0) write(*,*) "Error in amuse_handle_collisions - 1"
        
        err = set_stopping_condition_particle_index(sc_idx, 0, id1)
        if (err.LT.0) write(*,*) "Error in amuse_handle_collisions - 2"
        
        err = set_stopping_condition_particle_index(sc_idx, 1, id2)
        if (err.LT.0) write(*,*) "Error in amuse_handle_collisions - 3"
      end subroutine amuse_handle_collisions


      SUBROUTINE gravity_at_point(tnow, pointx, pointy, pointz,
     $   fx, fy, fz, p, number_of_points)
C===  calc the gravity at a point, cannot use data on the point
C===  for previous timesteps, so is less acurate
      IMPLICIT NONE
#include "general.inc"

C---  input vars
      INTEGER, intent(IN) :: number_of_points
      DOUBLE PRECISION tnow
      DOUBLE PRECISION pointx(number_of_points)
      DOUBLE PRECISION pointy(number_of_points),pointz(number_of_points)
      DOUBLE PRECISION :: fx(number_of_points), fy(number_of_points)
      DOUBLE PRECISION :: fz(number_of_points), p(number_of_points)

C---  GRAPE vars
      INTEGER    NGP
      PARAMETER (NGP=16384)

      INTEGER g6err, g6calc_lasthalf, g6calc_lasthalf2

C---  local vars
      INTEGER k, j, index_i(NGP), nn, i
      DOUBLE PRECISION x_i(NDIM,NGP),v_i(NDIM,NGP),a_i(NDIM,NGP),
     $                 jerk_i(NDIM,NGP),p_i(NGP),h2_i(NGP)

C---  set actual time on GRAPE
      CALL g6_set_ti(clusterid, tnow)

      DO i=0,number_of_points-1,npipe

         nn = npipe                         ! block size 48 or smaller
         IF ((number_of_points - i).LT.npipe) nn = number_of_points - i

C---  define the local phi, a, adot for these active particles
          DO j=1, nn
              index_i(j) = -1
              x_i(1,j) = pointx(j+i)
              x_i(2,j) = pointy(j+i)
              x_i(3,j) = pointz(j+i)
              h2_i(j)  = eps2
              p_i(j) = -1.d0
              DO k=1,NDIM
                a_i(k,j) = 1.d0
                v_i(k,j) = 0.d0
                jerk_i(k,j) = 10.d0
              ENDDO
          ENDDO

C---  get forces etc. based on bad initial guess
      CALL g6calc_firsthalf(clusterid, n_loc-nbh, nn,
     $           index_i,x_i,v_i,
     $           a_i, jerk_i, p_i, eps2, h2_i)
      g6err = g6calc_lasthalf(clusterid, n_loc-nbh, nn,
     $          index_i,x_i,v_i,
     $          eps2, h2_i, a_i, jerk_i, p_i)




C---  now get forces based on a (hopefully) good guess from a previous
C---  force calculation
      CALL g6calc_firsthalf(clusterid, n_loc-nbh, nn,
     $       index_i, x_i, v_i,
     $       a_i, jerk_i, p_i, eps2, h2_i)
      g6err = g6calc_lasthalf(clusterid, n_loc-nbh, nn,
     $          index_i,x_i,v_i,
     $          eps2, h2_i, a_i, jerk_i, p_i)

          DO j=1, nn
            fx(j+i) = a_i(1,j)
            fy(j+i) = a_i(2,j)
            fz(j+i) = a_i(3,j)
            p(j+i) = p_i(j)
          ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE readrestartfile
C=========================================================================
C===
C===  task:   read all run data from restart file
C===  -----
C=========================================================================
      IMPLICIT NONE
#include "general.inc"
#ifndef NOMPI
#include <mpif.h>
      INCLUDE 'mpi.inc'
      INTEGER ierr,idummy,ipe
      DOUBLE PRECISION xdummy
      INTEGER status(MPI_STATUS_SIZE)
#endif

C---  local vars
      INTEGER i,j,itag
      
      itag = 1

      IF (myRank.EQ.rootRank) THEN
         OPEN(urestf,FILE=restfile,FORM='UNFORMATTED')

c---  some header info
         READ(urestf) time_cur,N,diskstep

C---  main data
         READ(urestf) (ind(i),i=1,N)
         READ(urestf) (m(i),i=1,N)
         READ(urestf) ((x(j,i),j=1,3),i=1,N)
         READ(urestf) ((v(j,i),j=1,3),i=1,N)
         READ(urestf) ((a(j,i),j=1,3),i=1,N)
         READ(urestf) ((adot(j,i),j=1,3),i=1,N)
         READ(urestf) (pot(i),i=1,N)
         READ(urestf) (t(i),i=1,N)
         READ(urestf) (dt(i),i=1,N)
         READ(urestf) Timesteps,n_act_sum,n_act_sum2,cpu_total
         READ(urestf) t_disk,t_contr,t_bh,t_timing,t_restart
      ENDIF

C---  need to broadcast N here so all nodes now how much data they'll recv.
#ifndef NOMPI
      CALL MPI_Bcast(N,        1, MPI_INTEGER,    rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(time_cur, 1, MPI_DOUBLE_PRECISION, rootRank,
     $                                        MPI_COMM_WORLD,ierr)
#endif


C---  now need to read *_act_tmp_loc arrays and send to each PE so that
C---  local guessing for partial forces is correct after restart

C---  begin by reading root data; will be read later because
C---  arrays will be used as send buffer for now
C---  (NOTE: in serial runs no re-reading is needed which is why
C---         here the actual data is read instead of skipping over it)
      IF (myRank.EQ.rootRank) THEN
         READ(urestf) ((a_act_tmp_loc(j,i),j=1,3),i=1,N)
         READ(urestf) ((adot_act_tmp_loc(j,i),j=1,3),i=1,N)
         READ(urestf) (pot_act_tmp_loc(i),i=1,N)
      ENDIF

#ifndef NOMPI
      DO ipe=1,n_proc-1

C---  read data for PE ipe 
         IF (myRank.EQ.rootRank) THEN
            READ(urestf) ((a_act_tmp_loc(j,i),j=1,3),i=1,N)
            READ(urestf) ((adot_act_tmp_loc(j,i),j=1,3),i=1,N)
            READ(urestf) (pot_act_tmp_loc(i),i=1,N)
         ENDIF

C---  now send data from root to ipe 
         IF (myRank.EQ.rootRank) THEN 
            CALL MPI_SEND(a_act_tmp_loc, 3*N, MPI_DOUBLE_PRECISION,ipe,
     $                                  itag, MPI_COMM_WORLD,ierr)
            CALL MPI_SEND(adot_act_tmp_loc, 3*N, MPI_DOUBLE_PRECISION,
     $                             ipe,itag, MPI_COMM_WORLD,ierr)
            CALL MPI_SEND(pot_act_tmp_loc, 3*N, MPI_DOUBLE_PRECISION,
     $                                ipe,itag, MPI_COMM_WORLD,ierr)
         ELSE IF (myRank.EQ.ipe) THEN
            CALL MPI_RECV(a_act_tmp_loc, 3*N, MPI_DOUBLE_PRECISION,
     $                    rootRank,itag, MPI_COMM_WORLD,status,ierr)
            CALL MPI_RECV(adot_act_tmp_loc, 3*N, MPI_DOUBLE_PRECISION, 
     $                   rootRank,itag, MPI_COMM_WORLD,status,ierr)
            CALL MPI_RECV(pot_act_tmp_loc, 3*N, MPI_DOUBLE_PRECISION, 
     $                    rootRank,itag, MPI_COMM_WORLD,status,ierr)
         ENDIF

      ENDDO

C---  now get correct data back on root
      IF (myRank.EQ.rootRank) THEN
         CLOSE(urestf)
         OPEN(urestf,FILE=restfile,FORM='UNFORMATTED') ! reopen to read data

C---  skipping the part not needed
         READ(urestf) xdummy
         READ(urestf) idummy
         DO i=1,8
            READ(urestf) xdummy
         ENDDO
         READ(urestf) idummy
         READ(urestf) xdummy


C---  reading the needed data
         READ(urestf) ((a_act_tmp_loc(j,i),j=1,3),i=1,N)
         READ(urestf) ((adot_act_tmp_loc(j,i),j=1,3),i=1,N)
         READ(urestf) (pot_act_tmp_loc(i),i=1,N)

      ENDIF

C---  some data needs broadcasting
      CALL MPI_Bcast(Timesteps, 1, MPI_INTEGER,    rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(t_disk,    1, MPI_DOUBLE_PRECISION,rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(t_contr,   1, MPI_DOUBLE_PRECISION,rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(t_bh,      1, MPI_DOUBLE_PRECISION,rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(t_timing,  1, MPI_DOUBLE_PRECISION,rootRank,
     $                                        MPI_COMM_WORLD,ierr)
      CALL MPI_Bcast(t_restart, 1, MPI_DOUBLE_PRECISION,rootRank,
     $                                        MPI_COMM_WORLD,ierr)


#endif
C---  closing restart-file
      IF (myRank.EQ.rootRank) CLOSE(urestf)


      RETURN
      END
